﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Timers;
using System.Net.Sockets;
using System.Net;
using System.IO;

namespace WindowsApplication1
{ 
    
    public partial class Form1 : Form
    { 
     
        Program Program = new Program();
        public int res, k, Detect, cmd;
        public int m_hScanner = -1, m_hSocket = -1,OK = 0;
        public int nBaudRate = 0, Interval, EPC_Word;
        public string szPort;
        public int HardVersion, SoftVersion;
        public int  hwnd;
        public int nidEvent,mem,ptr,len;
        public int Read_times;
        public int m_antenna_sel,RS485Address;
        public byte Mask; 
        public byte []AccessPassword=new byte[4];
        public byte[] mask = new byte[96];
        public byte[] IDTemp = new byte[12];
        public byte[,] TagBuffer = new byte[100, 13];
        public byte[] AccessPassWord = new byte[4];
        public byte[,] TagNumber = new byte [100,8];
        public int ComMode;
        public string readerip;
        public uint readerport;
        public string hostip;
        public uint hostport;
        public byte connect_OK = 0;
        public int count_test = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox2.SelectedIndex = 3;
            comboBox9.SelectedIndex = 3;
            comboBox10.SelectedIndex = 3;
            comboBox19.SelectedIndex = 0;
            IPHostEntry ieh = Dns.GetHostByName(Dns.GetHostName());
            textBox37.Text = ieh.AddressList[0].ToString();
            int i;
            ListViewItem myitem = new ListViewItem();
            for (i = 0; i < 10; i++)
            {
                myitem = listView4.Items.Add((i + 1).ToString(), i);
                myitem.SubItems.Add("192.168.7.100");
                myitem.SubItems.Add("1969");
            }

        }

        #region EPCC1G2
        #region List Tag ID
        private void button3_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            nidEvent = 1;
            string str,strtemp;

            if (Convert.ToInt32(textBox1.Text) > 95 || Convert.ToInt32(textBox1.Text) < 0)
            {
                MessageBox.Show("Please input start address of data between 0 and 95!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox1.Focus();
                textBox1.SelectAll();
                button3.Text = "List Tag ID";
                return;
            }
            if (Convert.ToInt32(textBox2.Text) > 96 || Convert.ToInt32(textBox2.Text) < 0)
            {
                MessageBox.Show("Please input length of data between 0 and 96 !", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox2.Focus();
                textBox2.SelectAll();
                button3.Text = "List Tag ID";
                return;
            }
            str = textBox3.Text;
            int str_len = textBox3.Text.Length;
            int i, m,j;

            if (Convert.ToInt32(textBox2.Text) == 0)
                m = 0;
            else
            {
                m = Convert.ToInt32(textBox2.Text) / 8;
                if (Convert.ToInt32(textBox2.Text) % 8 != 0)
                {
                    for (i = 0; i < ((m + 1) * 2 - str_len); i++)
                        str += "0";
                    m++;
                }
            }

            if (radioButton1.Checked == true)
                mem = 0;
            if (radioButton2.Checked == true)
                mem = 1;
            if (radioButton3.Checked == true)
                mem = 2;
            if (radioButton4.Checked == true)
                mem = 3;

            ptr = Convert.ToInt16(textBox1.Text);
            len = Convert.ToInt16(textBox2.Text);

            for (i = 0; i < m; i++)
            {
                strtemp = str[i * 2].ToString() + str[i * 2 + 1].ToString();
                mask[i] = Convert.ToByte(strtemp);
            }
            int []timrinterval=new int []{10,20,30,50,100,200,500};
            Interval = timrinterval[comboBox2.SelectedIndex];
            if (button3.Text == "List Tag ID")
            {
                m_antenna_sel = 0;
                if (checkBox1.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox2.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox3.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox4.Checked == true)
                    m_antenna_sel += 8;
                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        button3.Text = "List Tag ID";
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            button3.Text = "List Tag ID";
                            return;
                        }
                        break;
                }
                button3.Text = "Stop";
                Read_times = 0;
                k=0;
                count_test = 0;
                listView1.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button3.Text = "List Tag ID";
                timer1.Enabled = false;
                comboBox3.Items.Clear();
                comboBox4.Items.Clear();
                comboBox5.Items.Clear();
                comboBox6.Items.Clear();
                comboBox7.Items.Clear();
                comboBox8.Items.Clear();
                byte  []dada=new byte[1024];
                for (i = 0; i < k; i++)
                {
                    str = listView1.Items[i].SubItems[2].Text;
                    TagBuffer[i, 0] = Convert.ToByte(str);
                    str = listView1.Items[i].SubItems[1].Text;
                    for(j=0;j<str.Length/2;j++)
                    {
                       strtemp = str[j * 2].ToString() + str[j * 2 + 1].ToString();
                       TagBuffer[i, j + 1] = (byte)Convert.ToInt16(strtemp,16);
                    }
                    strtemp = "";
                    strtemp = (i+1).ToString("D2") + ".";
                    comboBox3.Items.Add(strtemp + str);
                    comboBox4.Items.Add(strtemp + str);
                    comboBox5.Items.Add(strtemp + str);
                    comboBox6.Items.Add(strtemp + str);
                    comboBox7.Items.Add(strtemp + str);
                    comboBox8.Items.Add(strtemp + str);
                }
                if (k != 0)
                {
                    comboBox3.SelectedIndex = 0;
                    comboBox4.SelectedIndex = 0;
                    comboBox5.SelectedIndex = 0;
                    comboBox6.SelectedIndex = 0;
                    comboBox7.SelectedIndex = 0;
                    comboBox8.SelectedIndex = 0;
                }
            }

        }
#endregion
        #region KillerTag
        private void button4_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i, j;
            string str, strtemp;
            byte[]KillPassWord=new byte [4];


            if (comboBox4.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (textBox4.TextLength != 8)
            {
                MessageBox.Show("Please input correct killpassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox4.Focus();
                textBox4.SelectAll();
                return;
            }
            str = textBox4.Text;
            for (i = 0; i < 4; i++)
            {
                strtemp = str[i * 2].ToString() + str[i * 2 + 1].ToString();
                KillPassWord[i] = (byte)Convert.ToInt16(strtemp,16);

            }
            EPC_Word = TagBuffer[comboBox4.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox4.SelectedIndex ,0]*2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox4.SelectedIndex,i+1];
            }

            j = (int)MessageBox.Show("Are you sure to kill the tag ?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (j != 1)
                return;

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {     
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default :
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }
            for (i = 0; i < 5; i++)
            {
                Thread.Sleep(30);
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_KillTag(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, KillPassWord, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_EPC1G2_KillTag(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, KillPassWord);
                        break;
                }
                if ((res == OK) || (res == 5) || (res == 8) || (res == 9))
                    break;
            }
            if (res == OK)
            {
                MessageBox.Show("kill tag successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Kill tag Fail!";
                if (res == 9)
                    str = "The kill password is error!";
                MessageBox.Show(str, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }
        #endregion
        #region Timer
        private void timer1_Tick(object sender, EventArgs e)
        {
            int i, j, nCounter = 0, ID_len = 0, ID_len_temp = 0, be_antenna,success;
            string str, str_temp, strtemp;
            byte[] DB = new byte[128];
            byte[] IDBuffer = new byte[7680];

            Read_times++;
            Thread.Sleep(Interval);
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    break;
                case 3:
                case 5:
                case 9:
                    switch (Read_times % 2)
                    {
                        case 0:
                            be_antenna = m_antenna_sel - 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 6:
                case 10:
                    switch (Read_times % 2)
                    {
                        case 0:
                            be_antenna = m_antenna_sel - 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 12:
                    switch (Read_times % 2)
                    {
                        case 0:
                            be_antenna = m_antenna_sel - 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 7:
                    switch (Read_times % 3)
                    {
                        case 0:
                            be_antenna = 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 2:
                            be_antenna = 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 11:
                    switch (Read_times % 3)
                    {
                        case 0:
                            be_antenna = 8;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 2:
                            be_antenna = 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 13:
                    switch (Read_times % 3)
                    {
                        case 0:
                            be_antenna = 8;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 2:
                            be_antenna = 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 14:
                    switch (Read_times % 3)
                    {
                        case 0:
                            be_antenna = 8;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 2:
                            be_antenna = 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;

                case 15:
                    switch (Read_times % 4)
                    {
                        case 0:
                            be_antenna = 8;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 1:
                            be_antenna = 1;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 2:
                            be_antenna = 2;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                        case 3:
                            be_antenna = 4;
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            break;
                    }
                    break;
            }
            ListViewItem item = new ListViewItem();
            switch (nidEvent)
            {
                case 1:
                    Array.Clear(TagBuffer, 0, TagBuffer.Length);
                    count_test++;
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_ReadLabelID(m_hScanner, mem, ptr, len, mask, IDBuffer, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_ReadLabelID(m_hSocket, mem, ptr, len, mask, IDBuffer, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            if (IDBuffer[ID_len] > 6)
                            {
                                nCounter = 0;
                                break;
                            }
                            ID_len_temp = IDBuffer[ID_len] * 2 + 1;
                            for (j = 0; j < ID_len_temp; j++)
                            {
                                TagBuffer[i, j] = IDBuffer[ID_len + j];
                            }
                            ID_len += ID_len_temp;
                        }
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            strtemp = "";
                            ID_len = TagBuffer[i, 0] * 2;
                            for (j = 0; j < ID_len; j++)
                            {
                                strtemp = TagBuffer[i, j + 1].ToString("X2");
                                str += strtemp;
                            }

                            for (j = 0; j < k; j++)
                            {
                                strtemp = listView1.Items[j].SubItems[2].Text;
                                if (ID_len == Convert.ToInt32(strtemp) * 2)
                                {
                                    str_temp = listView1.Items[j].SubItems[1].Text;
                                    if (str == str_temp)
                                    {
                                        success = Convert.ToInt32(listView1.Items[j].SubItems[3].Text) + 1;
                                        listView1.Items[j].SubItems[3].Text = success.ToString();
                                        break;
                                    }
                                }
                            }
                            if (j == k)
                            {
                                item = listView1.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                item.SubItems.Add(TagBuffer[i, 0].ToString("X2"));
                                success = 1;
                                item.SubItems.Add(success.ToString());
                                item.SubItems.Add(count_test.ToString());
                                k++;
                                //listView1.Items.Add(item);
                            }
                        }

                    }
                    for (j = 0; j < k; j++)
                        listView1.Items[j].SubItems[4].Text = count_test.ToString();
                    break;
                case 2:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_ReadWordBlock(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), Convert.ToByte(textBox5.Text), Convert.ToByte(textBox6.Text), DB, AccessPassWord, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_ReadWordBlock(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), Convert.ToByte(textBox5.Text), Convert.ToByte(textBox6.Text), DB, AccessPassWord);
                            break;
                    }
                    if (res == OK)
                    {
                        str = "";
                        for (i = 0; i < Convert.ToByte(textBox6.Text) * 2; i++)
                        {
                            strtemp = DB[i].ToString("X2");
                            str += strtemp;
                        }
                        listBox1.Items.Add(str);
 
                    }
                    break;
                case 3:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_EasAlarm(m_hScanner, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_EasAlarm(m_hSocket);
                            break;
                    }
                    if (res == OK)
                    {
                        Program.MessageBeep(-1);
                    }
                        
 //                   Thread.Sleep(100);

                    break;
                case 4:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_DetectTag(m_hScanner, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_DetectTag(m_hSocket);
                            break;
                    }
                    switch (res)
                    {
                        case 0:
                            str = "There are tags in the field!";
                            Detect++;
                            break;
                        case 14:
                            str = "There are locked tags in the field!";
                            break;
                    }
                    if (3000 >= Read_times * Interval)
                    {
                        if (res == 14)
                        {
                            item = listView1.Items.Add((1).ToString(), 0);
                            item.SubItems.Add("There are locked tags in the field!");
//                            listView1.Items.Add(item);
                            button2.Text = "Detect Tag";
                            timer1.Enabled = false;
                        }
                       
                    }
                    else
                    {
                        if (Detect == 0)
                        {
                            item = listView1.Items.Add((1).ToString(), 0);
                            item.SubItems.Add("There is none of tag in the field!");
 //                           listView1.Items.Add(item);
                        }
                        else
                        {
                            item = listView1.Items.Add((1).ToString(), 0);
                            item.SubItems.Add("There are tags in the field!");
 //                         listView1.Items.Add(item);                          
                        }
                        button2.Text = "Detect Tag";
                        timer1.Enabled = false;
                    }
                    break;
                case 5:
                    Array.Clear(TagBuffer, 0, TagBuffer.Length);
                    count_test++;
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.ISO6B_ReadLabelID(m_hScanner, TagNumber, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_ISO6B_ReadLabelID(m_hSocket, TagNumber, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            for (j = 0; j < 8; j++)
                            {
                                str += TagNumber[i, j].ToString("X2");
                            }

                            for (j = 0; j < k; j++)
                            {
                                str_temp = listView2.Items[j].SubItems[1].Text;
                                if (str == str_temp)
                                {
                                    success = Convert.ToInt32(listView2.Items[j].SubItems[2].Text) + 1;
                                    listView2.Items[j].SubItems[2].Text = success.ToString();
                                    break;
                                }
                            }
                            if (j == k)
                            {
                                item = listView2.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                success = 1;
                                item.SubItems.Add(success.ToString());
                                item.SubItems.Add(count_test.ToString());
                                k++;
                            }

                        }
 
                    }
                    for (j = 0; j < k; j++)
                        listView2.Items[j].SubItems[3].Text = count_test.ToString();
                    break;
                case 6:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.ISO6B_ReadByteBlock(m_hScanner, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), mask, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_ISO6B_ReadByteBlock(m_hSocket, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), mask);
                            break;
                    }
                    if (res == OK)
                    {
                        str = "HEX:";
                        for(i=0;i<len;i++)
                        {
                            str_temp=mask[i].ToString("X2");
                            str += str_temp;
                        }
                        listBox2.Items.Add(str);
                        listBox2.Items.Add("---------------------------------");
                    }
                    break;
                case 7:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.ISO6B_WriteByteBlock(m_hScanner, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), mask, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_ISO6B_WriteByteBlock(m_hSocket, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), mask);
                            break;
                    }
                    if (res == OK)
                    {
                        listBox2.Items.Add("Write Successfully!");
                        listBox2.Items.Add("---------------------------------");
                    }
                    else
                    {
                        listBox2.Items.Add("Write Fail!");
                        listBox2.Items.Add("---------------------------------");
                    }
                    break;
                case 8:
                    count_test++;
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.ISO6B_ListSelectedID(m_hScanner, Convert.ToByte(cmd), Convert.ToByte(ptr), Mask, mask, TagNumber, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_ISO6B_ListSelectedID(m_hSocket, Convert.ToByte(cmd), Convert.ToByte(ptr), Mask, mask, TagNumber, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            for (j = 0; j < 8; j++)
                            {
                                str += TagNumber[i, j].ToString("X2");
                            }

                            for (j = 0; j < k; j++)
                            {
                                str_temp = listView2.Items[j].SubItems[1].Text;
                                if (str == str_temp)
                                {
                                    success = Convert.ToInt32(listView2.Items[j].SubItems[2].Text) + 1;
                                    listView2.Items[j].SubItems[2].Text = success.ToString();
                                    break;
                                }
                            }
                            if (j == k)
                            {
                                item = listView2.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                success = 1;
                                item.SubItems.Add(success.ToString());
                                item.SubItems.Add(count_test.ToString());
                                k++;
                            }

                        }

                    }
                    for (j = 0; j < k; j++)
                        listView2.Items[j].SubItems[3].Text = count_test.ToString();
                    break;
                case 9:
                    Array.Clear(TagBuffer, 0, TagBuffer.Length);
                    count_test++;
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.TK900_ReadLabelID(m_hScanner, TagNumber, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_TK900_ReadLabelID(m_hSocket, TagNumber, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            for (j = 0; j < 8; j++)
                            {
                                str += TagNumber[i, j].ToString("X2");
                            }

                            for (j = 0; j < k; j++)
                            {
                                str_temp = listView3.Items[j].SubItems[1].Text;
                                if (str == str_temp)
                                {
                                    success = Convert.ToInt32(listView3.Items[j].SubItems[2].Text) + 1;
                                    listView3.Items[j].SubItems[2].Text = success.ToString();
                                    break;
                                }
                            }
                            if (j == k)
                            {
                                item = listView3.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                success = 1;
                                item.SubItems.Add(success.ToString());
                                item.SubItems.Add(count_test.ToString());
                                k++;
                            }

                        }

                    }
                    for (j = 0; j < k; j++)
                        listView3.Items[j].SubItems[3].Text = count_test.ToString();
                    break;
                case 10:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.TK900_ReadPageBlock(m_hScanner, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), TagBuffer, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_TK900_ReadPageBlock(m_hSocket, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), TagBuffer);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < len; i++)
                        {
                            str = "No.";
                            str_temp=string.Format("{0:2D}",ptr + i );
                            str += str_temp;
                            str += " Page  HEX:";
                            str_temp = "str:";
                            for (j = 0; j < 8; j++)
                            {

                                strtemp = TagBuffer[i, j].ToString("X2");
                                str += strtemp;
                                str_temp += Convert.ToChar(TagBuffer[i,j]).ToString();
                                str += " ";
                            }
                            str += str_temp;
                            listBox3.Items.Add(str);
                        }
                    }
                    break;
                case 11:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.TK900_WritePageBlock(m_hScanner, IDTemp, Convert.ToByte(ptr), mask, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_TK900_WritePageBlock(m_hSocket, IDTemp, Convert.ToByte(ptr), mask);
                            break;
                    }
                    if (res == OK)
                    {
                        listBox3.Items.Add("Write Successfully!");
                        listBox3.Items.Add("--------------------------------------");
                    }
                    else
                    {
                        listBox3.Items.Add("Write Fail!");
                        listBox3.Items.Add("--------------------------------------");
                    }
                    break;
                case 12:
                    Array.Clear(TagBuffer, 0, TagBuffer.Length);
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_ReadLabelID(m_hScanner, 1, 0, 0, mask, IDBuffer, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_ReadLabelID(m_hSocket, 1, 0, 0, mask, IDBuffer, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            if (IDBuffer[ID_len] > 6)
                            {
                                nCounter = 0;
                                break;
                            }
                            ID_len_temp = IDBuffer[ID_len] * 2 + 1;
                            for (j = 0; j < ID_len_temp; j++)
                            {
                                TagBuffer[i, j] = IDBuffer[ID_len + j];
                            }
                            ID_len += ID_len_temp;
                        }
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            strtemp = "";
                            ID_len = TagBuffer[i, 0] * 2;
                            for (j = 0; j < ID_len; j++)
                            {
                                strtemp = TagBuffer[i, j + 1].ToString("X2");
                                str += strtemp;
                            }

                            for (j = 0; j < k; j++)
                            {
                                strtemp = listView5.Items[j].SubItems[2].Text;
                                if (ID_len == Convert.ToInt32(strtemp))
                                {
                                    str_temp = listView5.Items[j].SubItems[1].Text;
                                    if (str == str_temp)
                                        break;
                                }
                            }
                            if (j == k)
                            {
                                item = listView5.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                TagBuffer[i, 0] <<= 1;
                                item.SubItems.Add(TagBuffer[i, 0].ToString("D2"));
                                k++;
                                //listView1.Items.Add(item);
                            }
                        }
                    }
                    break;
                case 13:
                    Array.Clear(TagBuffer, 0, TagBuffer.Length);
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.ISO6B_ReadLabelID(m_hScanner, TagNumber, ref nCounter, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_ISO6B_ReadLabelID(m_hSocket, TagNumber, ref nCounter);
                            break;
                    }
                    if (res == OK)
                    {
                        for (i = 0; i < nCounter; i++)
                        {
                            str = "";
                            for (j = 0; j < 8; j++)
                            {
                                str += TagNumber[i, j].ToString("X2");
                            }

                            for (j = 0; j < k; j++)
                            {
                                str_temp = listView5.Items[j].SubItems[1].Text;
                                if (str == str_temp)
                                    break;
                            }
                            if (j == k)
                            {
                                item = listView5.Items.Add((k + 1).ToString(), k);
                                item.SubItems.Add(str);
                                item.SubItems.Add(8.ToString());
                                k++;
                            }

                        }

                    }
                    break;

            }
        }
        #endregion
        #region SetProtect
        private void button8_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i,j;
            string str;
            if (comboBox6.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (textBox11.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox11.Focus();
                textBox11.SelectAll();
                return;
            }
            if (Convert.ToInt16(textBox10.Text) < 0)
            {
                MessageBox.Show("Please input start address of tag more then 0!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox10.Focus();
                textBox10.SelectAll();
                return;
            }
            str = textBox11.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()),16);
            }
            ptr=Convert.ToByte(textBox10.Text);
            EPC_Word = TagBuffer[comboBox6.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox6.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox6.SelectedIndex, i + 1];
            }
            str = textBox10.Text;
            j = (int)MessageBox.Show("Are you sure to set protect address" + str + "of User?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (j != 1)
                return;

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }

            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_BlockLock(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(ptr), AccessPassword, RS485Address);
                        break;
                    case 1:
 //                       res = Program.Net_EPC1G2_BlockLock(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(ptr), AccessPassword);
                        break;
                }
                if ((res == OK) || (res == 5) || (res == 8) || (res == 9))
                    break;
            }
            if (res == OK)
            {
                MessageBox.Show("Set protect successfully!", "Notice", MessageBoxButtons.OKCancel, MessageBoxIcon.Information);
            }
            else
            {
                this.ReportError(ref str);
                if(str=="Unbeknown Error!")
                    str = "Fail to set protect!";
                if (res == 9)
                    str = "The access password is error!";
                MessageBox.Show(str, "ERROR", MessageBoxButtons.OKCancel, MessageBoxIcon.Error);
            }
        }
       #endregion
        #region ErrorInformation
        public void ReportError(ref string temp)
        {
            switch (res)
            {
                case 1:
                    temp = "Connect antenna fail!";
                    break;
                case 2:
                    temp = "No Tag!";
                    break;
                case 3:
                    temp = "Illegal Tag!";
                    break;
                case 4:
                    temp = "Power is not enough!";
                    break;
                case 5:
                    temp = "The memory has been protected!";
                    break;
                case 6:
                    temp = "Check sum error!";
                    break;
                case 7:
                    temp = "Parameter error!";
                    break;
                case 8:
                    temp = "The memory don't exist!";
                    break;
                case 9:
                    temp = "The Access Password is error!";
                    break;
                case 10:
                    temp = "The Kill Password cannot be 000000!";
                    break;
                case 14:
                    temp = "Locked Tags in the field!";
                    break;
                case 30:
                    temp = "Invalid Command!";
                    break;
                case 31:
                    temp = "Other Error!";
                    break;
                default:
                    temp = "Unbeknown Error!";
                    break;
            }
        }
        #endregion
        #region Read
        private void button5_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;
            nidEvent = 2;
            if (comboBox3.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt16(textBox5.Text) < 0)
            {
                MessageBox.Show("Please input start address of tag more then 0!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox5.Focus();
                textBox5.SelectAll();
                return;
            }
            if (Convert.ToInt16(textBox6.Text) < 1)
            {
                MessageBox.Show("Please input length of data more than 1!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox6.Focus();
                textBox6.SelectAll();
                return;
            }
            if (textBox7.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox7.Focus();
                textBox7.SelectAll();
                return;
            }
            str = textBox7.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = Convert.ToByte(str[i * 2] + str[i * 2 + 1]);
            }

            EPC_Word = TagBuffer[comboBox3.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox3.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox3.SelectedIndex, i + 1];
            }
            if (radioButton5.Checked  == true)
                mem = 0;
            if (radioButton6.Checked == true)
                mem = 1;
            if (radioButton7.Checked == true)
                mem = 2;
            if (radioButton8.Checked == true)
                mem = 3;


            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox2.SelectedIndex];
            if (button5.Text == "Read")
            {
                m_antenna_sel = 0;
                if (checkBox1.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox2.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox3.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox4.Checked == true)
                    m_antenna_sel += 8;
                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        button5.Text = "Read";
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            button5.Text = "Read";
                            return;
                        }
                        break;
                }
                button5.Text = "Stop";
                Read_times = 0;
                k = 0;
                listBox1.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button5.Text = "Read";
                timer1.Enabled = false;
            }

        }
        #endregion
        #region Write
        private void button6_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;
            listBox1.Items.Clear();

            if (textBox7.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox7.Focus();
                textBox7.SelectAll();
                return;
            }
          
            str = textBox7.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()),16);
            }
         
            if (radioButton5.Checked == true)
                mem = 0;
            if (radioButton6.Checked == true)
                mem = 1;
            if (radioButton7.Checked == true)
                mem = 2;
            if (radioButton8.Checked == true)
                mem = 3;
            switch (mem)
            {
                case 0:
                case 2:
                    if (Convert.ToInt16(textBox6.Text) < 1 || Convert.ToInt16(textBox6.Text) > 4)
                    {
                        MessageBox.Show("Please input Length of Tag Data between 1 and 4 Word !", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        textBox6.Focus();
                        textBox6.SelectAll();
                        return;
                    }
                    break;
                case 1:
                    if (Convert.ToInt16(textBox6.Text) < 1 || Convert.ToInt16(textBox6.Text) > 6)
                    {
                        MessageBox.Show("Please input Length of Tag Data between 1 and 6 Word !", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        textBox6.Focus();
                        textBox6.SelectAll();
                        return;
                    }
                    break;
                case 3:
                    if (Convert.ToInt16(textBox6.Text) < 1 || Convert.ToInt16(textBox6.Text) > 8)
                    {
                        MessageBox.Show("Please input Length of Tag Data between 1 and 6 Word !", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        textBox6.Focus();
                        textBox6.SelectAll();
                        return;
                    }
                    break;
            }

            if (textBox8.Text.Length == 0 || textBox8.Text.Length / 4 < Convert.ToInt16(textBox6.Text))
            {
                MessageBox.Show("Please input enough Length of Tag Data!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
/////////////////////////////////

            str = textBox8.Text;
            for (i = 0; i < textBox8.Text.Length / 2; i++)
            {
                mask[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()),16);
            }

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("SetAntenna Fail!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }
            len = Convert.ToInt16(textBox6.Text);
            if (mem == 1)
            {
                for (i = 0; i < 5; i++)
                {
                    Thread.Sleep(30);
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_WriteEPC(m_hScanner, Convert.ToByte(textBox6.Text), mask, AccessPassWord, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_WriteEPC(m_hSocket, Convert.ToByte(textBox6.Text), mask, AccessPassWord);
                            break;
                    }
                    if ((res == OK) || (res == 5) || (res == 8) || (res == 9))
                        break;
                }
            }
            else
            {
                if (comboBox3.SelectedIndex < 0)
                {
                    MessageBox.Show("Please read first than choose a tag!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
                switch (mem)
                {
                    case 0:
                    case 2:
                        if (Convert.ToInt16(textBox5.Text)<0 || Convert.ToInt16(textBox5.Text)>3)
                        {
                            MessageBox.Show("Please input Location of Tag Address between 0 and 4!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            textBox5.Focus();
                            textBox5.SelectAll();
                            return;
                        }
                        if ((len + Convert.ToInt16(textBox5.Text))>4)
                        {
                            len = 4 - Convert.ToInt16(textBox5.Text);
                        }
                        break;
                    case 3:
                        if (Convert.ToInt16(textBox5.Text) <0)
                        {
                            MessageBox.Show("Please input Location of Tag Address more than 0!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            textBox5.Focus();
                            textBox5.SelectAll();
                            return;
                        }
                        break;
                }
                EPC_Word = TagBuffer[comboBox3.SelectedIndex, 0];
                for (i = 0; i < TagBuffer[comboBox3.SelectedIndex, 0] * 2; i++)
                {
                    IDTemp[i] = TagBuffer[comboBox3.SelectedIndex, i + 1];
                }

                for (i = 0; i < 5; i++)
                {
                    Thread.Sleep(30);
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.EPC1G2_WriteWordBlock(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), Convert.ToByte(textBox5.Text), Convert.ToByte(len), mask, AccessPassWord, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_EPC1G2_WriteWordBlock(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), Convert.ToByte(textBox5.Text), Convert.ToByte(len), mask, AccessPassWord);
                            break;
                    }
                    if ((res == OK) || (res == 5) || (res == 8) || (res == 9))
                        break;
                }
            }

            if (res == OK)
            {
                listBox1.Items.Add("Write Successfully!");
            }
            else
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Write Fail!";
                if (res == 9)
                    str = "The access password is error!";
                listBox1.Items.Add(str);
            }
 
        }
        #endregion
        #region SetblockProtect
        private void button7_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            string str;
            int i, j;
            byte locked=0;

            if (comboBox5.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (textBox9.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox10.Focus();
                textBox10.SelectAll();
                return;
            }

            str = textBox9.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()),16);
            }

            EPC_Word = TagBuffer[comboBox5.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox5.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox5.SelectedIndex, i + 1];
            }

            j = (int)MessageBox.Show("Are you sure to protect this tag?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (j != 1)
                return;

            if (radioButton9.Checked == true)
            {
                if (radioButton13.Checked == true)
                    mem = 0;
                if (radioButton14.Checked == true)
                    mem = 1;
                if (radioButton15.Checked == true)
                    locked = 4;
                if (radioButton16.Checked == true)
                    locked = 5;
                if (radioButton17.Checked == true)
                    locked = 6;
                if (radioButton18.Checked == true)
                    locked = 7;

            }
            else
            {
                if (radioButton10.Checked == true)
                    mem=2;
                if (radioButton11.Checked == true)
                    mem = 3;
                if (radioButton12.Checked == true)
                    mem = 3;

                if (radioButton19.Checked == true)
                    locked = 0;
                if (radioButton20.Checked == true)
                    locked = 1;
                if (radioButton21.Checked == true)
                    locked = 2;
                if (radioButton22.Checked == true)
                    locked = 3;
            }

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }
            for(i=0;i<5;i++)
	        {
		        Thread.Sleep(30);
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_SetLock(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), locked, AccessPassWord, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_EPC1G2_SetLock(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(mem), locked, AccessPassWord);
                        break;
                }
		        if ((res==OK) || (res == 5) || (res == 8) || (res == 9))
			        break;
	        }
            if (res == OK)
            {
                MessageBox.Show("Set protect successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Fail to set protect!";
                if (res == 9)
                    str = "The accesspassword is error!";
                MessageBox.Show(str, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
            }


        }
        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            radioButton19.Enabled = false;
            radioButton20.Enabled = false;
            radioButton21.Enabled = false;
            radioButton22.Enabled = false;

            radioButton13.Enabled = true;
            radioButton14.Enabled = true;
            radioButton15.Enabled = true;
            radioButton16.Enabled = true;
            radioButton17.Enabled = true;
            radioButton18.Enabled = true;
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            radioButton19.Enabled = true;
            radioButton20.Enabled = true;
            radioButton21.Enabled = true;
            radioButton22.Enabled = true;

            radioButton13.Enabled = false;
            radioButton14.Enabled = false;
            radioButton15.Enabled = false;
            radioButton16.Enabled = false;
            radioButton17.Enabled = false;
            radioButton18.Enabled = false;
        }

        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            radioButton19.Enabled = true;
            radioButton20.Enabled = true;
            radioButton21.Enabled = true;
            radioButton22.Enabled = true;

            radioButton13.Enabled = false;
            radioButton14.Enabled = false;
            radioButton15.Enabled = false;
            radioButton16.Enabled = false;
            radioButton17.Enabled = false;
            radioButton18.Enabled = false;
        }

        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            radioButton19.Enabled = true;
            radioButton20.Enabled = true;
            radioButton21.Enabled = true;
            radioButton22.Enabled = true;

            radioButton13.Enabled = false;
            radioButton14.Enabled = false;
            radioButton15.Enabled = false;
            radioButton16.Enabled = false;
            radioButton17.Enabled = false;
            radioButton18.Enabled = false;
        }
        #endregion

        private void button9_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            string str;
            int i;
            if (comboBox7.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (textBox12.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox12.Focus();
                textBox12.SelectAll();
                return;
            }
            str = textBox12.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()), 16);
            }

            EPC_Word = TagBuffer[comboBox7.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox7.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox7.SelectedIndex, i + 1];
            }

            int Alarm = 0;
            if (radioButton23.Checked == true)
                Alarm = 0;
            if (radioButton24.Checked == true)
                Alarm = 1;

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }

            for (i = 0; i < 5; i++)
            {
                Thread.Sleep(30);
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_ChangeEas(m_hScanner, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(Alarm), AccessPassWord, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_EPC1G2_ChangeEas(m_hSocket, Convert.ToByte(EPC_Word), IDTemp, Convert.ToByte(Alarm), AccessPassWord);
                        break;
                }
                if (res == OK)
                    break;
            }

            if (res == OK)
            {
                MessageBox.Show("Set EAS alarm successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Fail to set EAS alarm!";
                if (res == 9)
                    str = "The accesspassword is error!";
                MessageBox.Show(str, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            nidEvent = 3;
            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox2.SelectedIndex];

            if (button10.Text == "EasAlarm")
            {
                m_antenna_sel = 0;
                if (checkBox1.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox2.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox3.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox4.Checked == true)
                    m_antenna_sel += 8;
                switch (m_antenna_sel)
                {
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != OK)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            button10.Text = "EasAlarm";
                            return;
                        }
                        break;
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        button10.Text = "EasAlarm";
                        return;
                }
                button10.Text = "Stop";
                Read_times = 0;
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else 
            {
                button10.Text = "EasAlarm";
                timer1.Enabled = false;
            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;
            if (comboBox8.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (textBox13.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox13.Focus();
                textBox13.SelectAll();
                return;
            }

            str = textBox13.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()), 16);
            }

            EPC_Word = TagBuffer[comboBox8.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox8.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox8.SelectedIndex, i + 1];
            }

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }

            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_ReadProtect(m_hScanner, AccessPassword, Convert.ToByte(EPC_Word), IDTemp, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_EPC1G2_ReadProtect(m_hSocket, AccessPassword, Convert.ToByte(EPC_Word), IDTemp);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Fail to read protect!Please try again!";
                MessageBox.Show(str, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else
            {
                MessageBox.Show("Read protect successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information );
            }


        }

        private void button12_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;

            if (textBox13.Text.Length != 8)
            {
                MessageBox.Show("Please input correct accesspassword!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox13.Focus();
                textBox13.SelectAll();
                return;
            }

            str = textBox13.Text;
            for (i = 0; i < 4; i++)
            {
                AccessPassWord[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()), 16);
            }

            EPC_Word = TagBuffer[comboBox8.SelectedIndex, 0];
            for (i = 0; i < TagBuffer[comboBox8.SelectedIndex, 0] * 2; i++)
            {
                IDTemp[i] = TagBuffer[comboBox8.SelectedIndex, i + 1];
            }

            m_antenna_sel = 0;
            if (checkBox1.Checked == true)
                m_antenna_sel += 1;
            if (checkBox2.Checked == true)
                m_antenna_sel += 2;
            if (checkBox3.Checked == true)
                m_antenna_sel += 4;
            if (checkBox4.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }

            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.EPC1G2_RStreadProtect(m_hScanner, AccessPassword, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_EPC1G2_RStreadProtect(m_hSocket, AccessPassword);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                this.ReportError(ref str);
                if (str == "Unbeknown Error!")
                    str = "Fail to unlock read protect!Please try again!";
                MessageBox.Show(str, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else
            {
                MessageBox.Show("UnLockRead successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        //Detect Tag
        private void button2_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            Detect = 0;
            nidEvent = 4;

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox2.SelectedIndex];

            if (button2.Text == "Detect Tag")
            {
                m_antenna_sel = 0;
                if (checkBox1.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox2.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox3.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox4.Checked == true)
                    m_antenna_sel += 8;
                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        button2.Text = "Detect Tag";
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna !Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            button2.Text = "Detect Tag";
                            return;
                        }
                        break;
                }
                button2.Text = "Stop";
                Read_times = 0;
                k = 0;
                listView1.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button2.Text = "Detect Tag";
                timer1.Enabled = false;
            }
        }
  #endregion
        #region ISO6B_Test
        private void button13_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i,j;
            string str, strtemp;
            nidEvent = 5;

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox9.SelectedIndex];
            if (button13.Text == "List Tag ID")
            {
                m_antenna_sel = 0;
                if (checkBox9.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox10.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox11.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox12.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button13.Text = "Stop";
                Read_times = 0;
                k = 0;
                listView2.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;

            }
            else
            {
                button13.Text = "List Tag ID";
                timer1.Enabled = false;
                comboBox12.Items.Clear();

                for (i = 0; i < k; i++)
                {
                    str = listView2.Items[i].SubItems[1].Text;
                    for (j = 0; j < str.Length / 2; j++)
                    {
                        TagNumber[i, j] = (byte)Convert.ToInt16((str[j * 2].ToString() + str[j * 2 + 1].ToString()), 16);
                    }
                    strtemp = (i + 1).ToString("D2") + ".";
                    comboBox12.Items.Add(strtemp + str);
                }
                if (k != 0)
                {
                    comboBox12.SelectedIndex = 0;
                }
            }

        }

        private void button14_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            nidEvent = 6;

            if (comboBox12.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt16(textBox14.Text) < 0 || Convert.ToInt16(textBox14.Text) > 223)
            {
                MessageBox.Show("Please input start address of Tag between 0 and 223!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox14.Focus();
                textBox14.SelectAll();
                return;
            }

            if (Convert.ToInt16(textBox15.Text) < 1 || Convert.ToInt16(textBox15.Text) > 32)
            {
                MessageBox.Show("Please input length of data between 1 and 32!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox15.Focus();
                textBox15.SelectAll();
                return;
            }

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox9.SelectedIndex];

            ptr = Convert.ToInt16(textBox14.Text);
            len = Convert.ToInt16(textBox15.Text);
            if (ptr + len > 224)
                len = 224 - ptr;

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox12.SelectedIndex, i];
            }

            if (button14.Text == "Read")
            {
                m_antenna_sel = 0;
                if (checkBox9.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox10.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox11.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox12.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button14.Text = "Stop";
                Read_times = 0;
//                k = 0;
//                listView1.Items.Clear();
                listBox2.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button14.Text = "Read";
                timer1.Enabled = false;
            }



        }

        private void button15_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;
            nidEvent =7;
            if (comboBox12.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt16(textBox14.Text) < 8 || Convert.ToInt16(textBox14.Text) > 223)
            {
                MessageBox.Show("Please input start address of Tag between 8 and 223!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox14.Focus();
                textBox14.SelectAll();
                return;
            }

            if (Convert.ToInt16(textBox15.Text) < 1 || Convert.ToInt16(textBox15.Text) > 16)
            {
                MessageBox.Show("Please input length of data between 1 and 16!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox15.Focus();
                textBox15.SelectAll();
                return;
            }

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox9.SelectedIndex];

            ptr = Convert.ToInt16(textBox14.Text);
            len = Convert.ToInt16(textBox15.Text);
            if (ptr + len > 224)
                len = 224 - ptr;

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox12.SelectedIndex, i];
            }

            str = textBox16.Text;
            for (i = 0; i < textBox16.Text.Length / 2; i++)
            {
                mask[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()), 16);
            }

            if (button15.Text == "Write")
            {
                m_antenna_sel = 0;
                if (checkBox9.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox10.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox11.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox12.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button15.Text = "Stop";
                Read_times = 0;
                //                k = 0;
                //                listView1.Items.Clear();
                listBox2.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button15.Text = "Write";
                timer1.Enabled = false;
            }
        }

        private void button16_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i, j;
            if (comboBox12.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt16(textBox17.Text) < 8 || Convert.ToInt16(textBox17.Text) > 223)
            {
                MessageBox.Show("Please input an address of tag memory between 8 and 223!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox17.Focus();
                textBox17.SelectAll();
                return;
            }
            ptr = Convert.ToInt16(textBox17.Text);

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox12.SelectedIndex, i];
            }

            j = (int)MessageBox.Show("Do you determine to protect address"+ptr.ToString()+" of the tag ?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (j != 1)
                return;

            m_antenna_sel = 0;
            if (checkBox9.Checked == true)
                m_antenna_sel += 1;
            if (checkBox10.Checked == true)
                m_antenna_sel += 2;
            if (checkBox11.Checked == true)
                m_antenna_sel += 4;
            if (checkBox12.Checked == true)
                m_antenna_sel += 8;

            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != 0)
                    {
                        MessageBox.Show("Fail to set antenna!Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }
            switch (ComMode)
            {
                case 0:
                    res = Program.ISO6B_WriteProtect(m_hScanner, IDTemp, Convert.ToByte(ptr), RS485Address);
                    break;
                case 1:
                    res = Program.Net_ISO6B_WriteProtect(m_hSocket, IDTemp, Convert.ToByte(ptr));
                    break;
            }
            if (res == OK)
            {
                MessageBox.Show("Set write protect successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                MessageBox.Show("Fail to set write protect !Please try again!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void button17_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            byte protect=0;
            if (comboBox12.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt16(textBox17.Text) < 0 || Convert.ToInt16(textBox17.Text) > 223)
            {
                MessageBox.Show("Please input an address of tag memory between 0 and 223!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox17.Focus();
                textBox17.SelectAll();
                return;
            }

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox12.SelectedIndex, i];
            }

            m_antenna_sel = 0;
            if (checkBox9.Checked == true)
                m_antenna_sel += 1;
            if (checkBox10.Checked == true)
                m_antenna_sel += 2;
            if (checkBox11.Checked == true)
                m_antenna_sel += 4;
            if (checkBox12.Checked == true)
                m_antenna_sel += 8;

            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    for (i = 0; i < 3; i++)
                    {
                        switch (ComMode)
                        {
                            case 0:
                                res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                break;
                            case 1:
                                res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                break;
                        }
                        if (res == OK)
                            break;

                    }
                    if (res != 0)
                    {
                        MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose one antenna!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }

            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.ISO6B_ReadWriteProtect(m_hScanner, IDTemp, Convert.ToByte(ptr), ref protect, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_ISO6B_ReadWriteProtect(m_hSocket, IDTemp, Convert.ToByte(ptr), ref protect);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res == OK)
            {
                switch (protect)
                {
                    case 0:
                        MessageBox.Show("The address" + ptr.ToString() + " has not been written protection!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        break;
                    case 1:
                        MessageBox.Show("The address" + ptr.ToString() + " has been written protection!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        break;
                }
                
            }
            else
            {
                MessageBox.Show("Fail to check protect! Please try again!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }
        //条件选卡
        private void button18_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            string str, strtemp;
            int i,j;
            nidEvent = 8;
            cmd = 0;

            if (radioButton25.Checked == true)
                cmd += 0;
            if (radioButton26.Checked == true)
                cmd += 1;
            if (radioButton27.Checked == true)
                cmd += 2;
            if (radioButton28.Checked == true)
                cmd += 3;

            if (Convert.ToInt16(textBox18.Text) < 0 || Convert.ToInt16(textBox18.Text) > 223)
            {
                MessageBox.Show("Please input the start address of data between 0 and 223!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox18.Focus();
                textBox18.SelectAll();
                return;
            }
            ptr = Convert.ToInt16(textBox18.Text);
            if (textBox19.Text.Length>8)
            {
                MessageBox.Show("Please input suitable length data!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox18.Focus();
                textBox18.SelectAll();
                return;
            }
            str = textBox19.Text;

            for (i = 0; i < textBox19.Text.Length / 2; i++)
            {
                mask[i] = (byte)Convert.ToInt16((str[i * 2].ToString() + str[i * 2 + 1].ToString()), 16);
            }

            switch (textBox19.Text.Length/2)
            {
                case 1:
                    Mask = 0x80;
                    break;
                case 2:
                    Mask = 0xC0;
                    break;
                case 3:
                    Mask = 0xE0;
                    break;
                case 4:
                    Mask = 0xF0;
                    break;
                case 5:
                    Mask = 0xF8;
                    break;
                case 6:
                    Mask = 0xFC;
                    break;
                case 7:
                    Mask = 0xfe;
                    break;
                case 8:
                    Mask = 0xFF;
                    break;
            }


            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox9.SelectedIndex];
            if (button18.Text == "List ID of Selected Tags")
            {
                m_antenna_sel = 0;
                if (checkBox9.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox10.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox11.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox12.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button18.Text = "Stop";
                Read_times = 0;
                k = 0;
                listView2.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;

            }
            else
            {
                button18.Text = "List ID of Selected Tags";
                timer1.Enabled = false;
                comboBox12.Items.Clear();

                for (i = 0; i < k; i++)
                {
                    str = listView2.Items[i].SubItems[1].Text;
                    for (j = 0; j < str.Length / 2; j++)
                    {
                        TagNumber[i, j] = (byte)Convert.ToInt16((str[j * 2].ToString() + str[j * 2 + 1].ToString()), 16);
                    }
                    strtemp = (i + 1).ToString("D2") + ".";
                    comboBox12.Items.Add(strtemp + str);
                }
            }

        }
        #endregion

        private void button19_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i, j;
            string str, strtemp;
            nidEvent = 9;

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox10.SelectedIndex];
            if (button19.Text == "List Tag ID")
            {
                m_antenna_sel = 0;
                if (checkBox5.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox6.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox7.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox8.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button19.Text = "Stop";
                Read_times = 0;
                k = 0;
                listView3.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;

            }
            else
            {
                button19.Text = "List Tag ID";
                timer1.Enabled = false;
                comboBox11.Items.Clear();

                for (i = 0; i < k; i++)
                {
                    str = listView3.Items[i].SubItems[1].Text;
                    for (j = 0; j < str.Length / 2; j++)
                    {
                        TagNumber[i, j] = (byte)Convert.ToInt16((str[j * 2].ToString() + str[j * 2 + 1].ToString()), 16);
                    }
                    strtemp = (i + 1).ToString("D2") + ".";
                    comboBox11.Items.Add(strtemp + str);
                }
                if (k != 0)
                {
                    comboBox11.SelectedIndex = 0;
                }
            }
        }

        private void button20_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            nidEvent = 10;

            if (comboBox11.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (Convert.ToInt16(textBox20.Text) < 0 || Convert.ToInt16(textBox20.Text) >14)
            {
                MessageBox.Show("Please input start page of tag between 0 and 14!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox20.Focus();
                textBox20.SelectAll();
                return;
            }
            ptr = Convert.ToInt16(textBox20.Text);

            if (Convert.ToInt16(textBox21.Text) < 1 || Convert.ToInt16(textBox21.Text) > 15)
            {
                MessageBox.Show("Please input length of page between 0 and 14!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox21.Focus();
                textBox21.SelectAll();
                return;
            }
            len = Convert.ToInt16(textBox21.Text);
            if (len + ptr > 15)
                len = 15 - ptr;

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox11.SelectedIndex, i];
            }
            if ((IDTemp[0] & 0x40) != 0x40)
            {
                MessageBox.Show("The tag can't be read and written!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
            Interval = timrinterval[comboBox10.SelectedIndex];
            if (button20.Text == "Read")
            {
                m_antenna_sel = 0;
                if (checkBox5.Checked == true)
                    m_antenna_sel += 1;
                if (checkBox6.Checked == true)
                    m_antenna_sel += 2;
                if (checkBox7.Checked == true)
                    m_antenna_sel += 4;
                if (checkBox8.Checked == true)
                    m_antenna_sel += 8;

                switch (m_antenna_sel)
                {
                    case 0:
                        MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                        for (i = 0; i < 3; i++)
                        {
                            switch (ComMode)
                            {
                                case 0:
                                    res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                    break;
                                case 1:
                                    res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                    break;
                            }
                            if (res == OK)
                                break;

                        }
                        if (res != 0)
                        {
                            MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                        break;
                }

                button20.Text = "Stop";
                Read_times = 0;
                k = 0;
                listBox3.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;

            }
            else
            {
                button20.Text = "Read";
                timer1.Enabled = false;
            }

        }
        //写数据
        private void button21_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            string str;
            nidEvent = 11;

            if (comboBox11.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (Convert.ToInt16(textBox20.Text) < 0 || Convert.ToInt16(textBox20.Text) > 14)
            {
                MessageBox.Show("Please input start page of tag between 0 and 14!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox20.Focus();
                textBox20.SelectAll();
                return;
            }

            if (textBox22.Text.Length > 8)
            {
                MessageBox.Show("Please input written data not more than 8 bytes!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

           for (i = 0; i < 8; i++)
           {
               IDTemp[i] = TagNumber[comboBox11.SelectedIndex, i];
           }
          if ((IDTemp[0] & 0x40) != 0x40)
          {
              MessageBox.Show("The tag can't be read and written!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
              return;
          }


          int[] timrinterval = new int[] { 10, 20, 30, 50, 100, 200, 500 };
          Interval = timrinterval[comboBox10.SelectedIndex];
          if (button21.Text == "Write")
          {
              m_antenna_sel = 0;
              if (checkBox5.Checked == true)
                  m_antenna_sel += 1;
              if (checkBox6.Checked == true)
                  m_antenna_sel += 2;
              if (checkBox7.Checked == true)
                  m_antenna_sel += 4;
              if (checkBox8.Checked == true)
                  m_antenna_sel += 8;

              switch (m_antenna_sel)
              {
                  case 0:
                      MessageBox.Show("Please choose one antenna at least!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                      return;
                  case 1:
                  case 2:
                  case 4:
                  case 8:
                      for (i = 0; i < 3; i++)
                      {
                          switch (ComMode)
                          {
                              case 0:
                                  res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                                  break;
                              case 1:
                                  res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                                  break;
                          }
                          if (res == OK)
                              break;

                      }
                      if (res != 0)
                      {
                          MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                          return;
                      }
                      break;
              }


              int protect;
              for (i = 0; i < 30; i++)
              {
                  Thread.Sleep(50);
                  switch (ComMode)
                  {
                      case 0:
                          res = Program.TK900_GetProtect(m_hScanner, IDTemp, mask, RS485Address);
                          break;
                      case 1:
                          res = Program.Net_TK900_GetProtect(m_hSocket, IDTemp, mask);
                          break;
                  }
                  if (res == OK)
                      break;
              }
              if (res == OK)
              {
                  if (ptr < 8)
                  {
                      protect = (mask[1] >> ptr) & 0x01;
                  }
                  else
                  {
                      protect = (mask[0] >> (ptr - 8)) & 0x01;
                  }

                  if (protect==1)
                  {
                      MessageBox.Show("Page" + ptr.ToString() + " is locked!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                      return;
                  }
              }
              else
              {
                  MessageBox.Show("No tag! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                  return;
              }
              str = textBox22.Text;
              if (textBox22.Text.Length < 8)
              {
                  for (i = 0; i < (8 - textBox22.Text.Length); i++)
                  {
                      str += " ";
                  }
              }
              for (i = 0; i < 8; i++)
              {
                  mask[i] =Convert.ToByte( str[i]);
              }

              button21.Text = "Stop";
              Read_times = 0;
              k = 0;
              listBox3.Items.Clear();
              timer1.Interval = Interval;
              timer1.Enabled = true;

          }
          else
          {
              button21.Text = "Write";
              timer1.Enabled = false;
          }


        }
        //SetProtect
        private void button22_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;

            if (comboBox11.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (Convert.ToInt16(textBox23.Text) < 0 || Convert.ToInt16(textBox23.Text) > 15)
            {
                MessageBox.Show("Please input start page of tag between 0 and 15!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox23.Focus();
                textBox23.SelectAll();
                return;
            }
            ptr = Convert.ToInt16(textBox23.Text);

            if (Convert.ToInt16(textBox24.Text) < 0 || Convert.ToInt16(textBox24.Text) > 15)
            {
                MessageBox.Show("Please input length of page between 1 and 15!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox24.Focus();
                textBox24.SelectAll();
                return;
            }
            len = Convert.ToInt16(textBox24.Text);

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox11.SelectedIndex, i];
            }

            if ((IDTemp[0] & 0x40) != 0x40)
            {
                MessageBox.Show("The tag can't be read and written!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            listBox3.Items.Clear();
            m_antenna_sel = 0;
            if (checkBox5.Checked == true)
                m_antenna_sel += 1;
            if (checkBox6.Checked == true)
                m_antenna_sel += 2;
            if (checkBox7.Checked == true)
                m_antenna_sel += 4;
            if (checkBox8.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                            break;
                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose only one antenna!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }


            int protect;
            for (i = 0; i < 30; i++)
            {
                Thread.Sleep(50);
                switch (ComMode)
                {
                    case 0:
                        res = Program.TK900_GetProtect(m_hScanner, IDTemp, mask, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_TK900_GetProtect(m_hSocket, IDTemp, mask);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res == OK)
            {
                if (ptr < 8)
                {
                    protect = (mask[1] >> ptr) & 0x01;
                }
                else
                {
                    protect = (mask[0] >> (ptr - 8)) & 0x01;
                }

                if (protect == 1)
                {
                    MessageBox.Show("Page" + ptr.ToString() + " is locked!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }
            else
            {
                MessageBox.Show("No tag! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            i = (int)MessageBox.Show("Do you determine to set protecrt page ?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (i != 1)
                return;

            switch (ComMode)
            {
                case 0:
                    res = Program.TK900_SetProtect(m_hScanner, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len), RS485Address);
                    break;
                case 1:
                    res = Program.Net_TK900_SetProtect(m_hSocket, IDTemp, Convert.ToByte(ptr), Convert.ToByte(len));
                    break;
            }
            if (res == OK)
            {
                listBox3.Items.Add("Set protect successfully!");
            }
            else
            {
                listBox3.Items.Add("Fail to set protect!");
            }

        }

        private void button23_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;

            if (comboBox11.SelectedIndex < 0)
            {
                MessageBox.Show("Please identify a tag first!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (Convert.ToInt16(textBox23.Text) < 0 || Convert.ToInt16(textBox23.Text) > 15)
            {
                MessageBox.Show("Please input start page of tag between 0 and 15!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox23.Focus();
                textBox23.SelectAll();
                return;
            }

            ptr = Convert.ToInt16(textBox23.Text);

            listBox3.Items.Clear();

            for (i = 0; i < 8; i++)
            {
                IDTemp[i] = TagNumber[comboBox11.SelectedIndex, i];
            }

            if ((IDTemp[0] & 0x40) != 0x40)
            {
                MessageBox.Show("The tag can't be read and written!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            listBox3.Items.Clear();
            m_antenna_sel = 0;
            if (checkBox5.Checked == true)
                m_antenna_sel += 1;
            if (checkBox6.Checked == true)
                m_antenna_sel += 2;
            if (checkBox7.Checked == true)
                m_antenna_sel += 4;
            if (checkBox8.Checked == true)
                m_antenna_sel += 8;
            switch (m_antenna_sel)
            {
                case 1:
                case 2:
                case 4:
                case 8:
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.SetAntenna(m_hScanner, m_antenna_sel, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_SetAntenna(m_hSocket, m_antenna_sel);
                            break;
                    }
                    if (res != OK)
                    {
                        MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    break;
                default:
                    MessageBox.Show("Please choose only one antenna!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
            }


            int protect;
            for (i = 0; i < 30; i++)
            {
                Thread.Sleep(50);
                switch (ComMode)
                {
                    case 0:
                        res = Program.TK900_GetProtect(m_hScanner, IDTemp, mask, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_TK900_GetProtect(m_hSocket, IDTemp, mask);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res == OK)
            {
                if (ptr < 8)
                {
                    protect = (mask[1] >> ptr) & 0x01;
                }
                else
                {
                    protect = (mask[0] >> (ptr - 8)) & 0x01;
                }
                string str;
                str = "Page ";
                str += ptr.ToString();
                if (protect==1)
                {
                    str += " is locked.";
                }
                else
                {
                    str += " is unlocked.";
                }
                listBox3.Items.Add(str);
            }
            else
            {
                listBox3.Items.Add("Fail to get protect!");
            }
        }
        //UP
        private void button24_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i, Ant, WorkMode = 0, TagType = 0,port;
            string[] ipinfo = new string[4];
            byte[] readerip = new byte[4];
            byte[] mask = new byte[4];
            byte[] gateway = new byte[4];
            Program.Parameter Param = new Program.Parameter();

            port = Convert.ToInt16(textBox40.Text);
            ipinfo = textBox28.Text.Split(new Char[] { '.' });
            for (i = 0; i < 4; i++)
            {
                readerip[i] = Convert.ToByte(ipinfo[i]);
            }
            ipinfo = textBox41.Text.Split(new Char[] { '.' });
            for (i = 0; i < 4; i++)
            {
                mask[i] = Convert.ToByte(ipinfo[i]);
            }
            ipinfo = textBox42.Text.Split(new Char[] { '.' });
            for (i = 0; i < 4; i++)
            {
                gateway[i] = Convert.ToByte(ipinfo[i]);
            }

            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.SetReaderNetwork(m_hScanner, readerip, port, mask, gateway);
                        break;
                    case 1:
                        res = Program.Net_SetReaderNetwork(m_hSocket, readerip, port, mask, gateway);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Fail to update reader network!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            
            if (comboBox14.SelectedIndex > comboBox15.SelectedIndex)
            {
                MessageBox.Show("The Min of Frequency can't be greater than the Max of Frequency!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (Convert.ToInt32(textBox27.Text) > 160 || Convert.ToInt32(textBox27.Text) < 0)
            {
                MessageBox.Show("Please input RF power between 0 and 160!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox27.Focus();
                textBox27.SelectAll();
                return;
            }
            if (Convert.ToInt32(textBox29.Text) > 100 || Convert.ToInt32(textBox29.Text) < 0)
            {
                MessageBox.Show("Please input Max. tags of once Reading between 1 and 100!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox29.Focus();
                textBox29.SelectAll();
                return;
            }

            if (Convert.ToInt32(textBox34.Text) > 254 || Convert.ToInt32(textBox34.Text) < 1)
            {
                MessageBox.Show("Please input reader address between 1 and 254 !", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox34.Focus();
                textBox34.SelectAll();
                return;
            }


            if (Convert.ToInt32(textBox31.Text) < 1 || Convert.ToInt32(textBox31.Text) > 255)
            {
                MessageBox.Show("Please input pulse width between 1 and 255!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox31.Focus();
                textBox31.SelectAll();
                return;
            }
            if (Convert.ToInt32(textBox30.Text) < 1 || Convert.ToInt32(textBox30.Text) > 255)
            {
                MessageBox.Show("Please input pulse interval between 1 and 255!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox30.Focus();
                textBox30.SelectAll();
                return;
            }
            if (Convert.ToInt32(textBox32.Text) < 1 || Convert.ToInt32(textBox32.Text) > 255)
            {
                MessageBox.Show("Please input interval of reading for standard between 1 and 255!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                textBox32.Focus();
                textBox32.SelectAll();
                return;
            }
            if (radioButton38.Checked == true)
            {
                if (Convert.ToInt32(textBox33.Text) < 0 || Convert.ToInt32(textBox33.Text) > 8)
                {
                    MessageBox.Show("Please input interval of reading for sStandard between 0 and 8!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    textBox33.Focus();
                    textBox33.SelectAll();
                    return;
                }
            }
            else
            {
                if (Convert.ToInt32(textBox33.Text) < 0 || Convert.ToInt32(textBox33.Text) > 4)
                {
                    MessageBox.Show("Please input interval of reading for standard between 0 and 4!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    textBox33.Focus();
                    textBox33.SelectAll();
                    return;
                }
            }

            Ant = 0;
            if (checkBox14.Checked == true)
                Ant += 1;
            if (checkBox15.Checked == true)
                Ant += 2;
            if (checkBox16.Checked == true)
                Ant += 4;
            if (checkBox17.Checked == true)
                Ant += 8;

            if (radioButton29.Checked == true)
                WorkMode = 0;
            if (radioButton30.Checked == true)
                WorkMode = 1;
            if (radioButton31.Checked == true)
                WorkMode = 2;

            if (radioButton36.Checked == true)
                TagType = 1;
            if (radioButton38.Checked == true)
                TagType = 4;
            if (radioButton39.Checked == true)
                TagType = 8;

            int OutInterface = 0, OutMode = 0, Enablebuzzer = 0;
            if (radioButton32.Checked == true)
                OutInterface = 0;
            if (radioButton33.Checked == true)
                OutInterface = 1;
            if (radioButton34.Checked == true)
                OutInterface = 2;
            if (radioButton35.Checked == true)
                OutInterface = 3;
            if (radioButton37.Checked == true)
                OutInterface = 4;

            if (radioButton40.Checked == true)
                OutMode = 0;
            if (radioButton41.Checked == true)
                OutMode = 1;
            if (checkBox13.Checked == true)
                Enablebuzzer += 1;

            if (checkBox20.Checked == true)
                Enablebuzzer += 8;

            if (Convert.ToInt16(textBox25.Text) / 100 == 24 || Convert.ToInt16(textBox25.Text) / 100 == 26
                || Convert.ToInt16(textBox25.Text) / 100 == 10 || Convert.ToInt16(textBox25.Text) / 100 == 11)
            {
               Param.ReadDuration=(byte)comboBox17.SelectedIndex;
 
            }
            Param.BaudRate = (byte)(comboBox13.SelectedIndex+4);
            Param.Min_Frequence=(byte)(comboBox14.SelectedIndex+1);
            Param.Max_Frequence = (byte)(comboBox15.SelectedIndex + 1);
            Param.WorkMode = (byte)WorkMode;
            Param.Antenna=(byte)Ant;
            Param.EnableBuzzer = (byte)Enablebuzzer;
            Param.OutInterface = (byte)OutInterface;
            Param.OutMode = (byte)OutMode;
            Param.Power = Convert.ToByte(textBox27.Text);
            Param.ReadInterval = (byte)comboBox18.SelectedIndex;
            Param.StandardTime = Convert.ToByte(textBox32.Text);
            Param.TagType = (byte)TagType;
            Param.WiegandInterval = Convert.ToByte(textBox30.Text);
            Param.WiegandWidth = Convert.ToByte(textBox31.Text);
            Param.NumofCard = Convert.ToByte(textBox29.Text);
            Param.ID_Start = Convert.ToByte(textBox33.Text);
            Param.ReaderAddress = Convert.ToByte(textBox34.Text);

            port = Convert.ToInt32(textBox44.Text);
            ipinfo = textBox43.Text.Split(new Char[] { '.' });
            Param.HostIP1 = Convert.ToByte(ipinfo[0]);
            Param.HostIP2 = Convert.ToByte(ipinfo[1]);
            Param.HostIP3 = Convert.ToByte(ipinfo[2]);
            Param.HostIP4 = Convert.ToByte(ipinfo[3]);
            Param.HostPort1 = (byte)((port >> 8) & 0xFF);
            Param.HostPort2 = (byte)(port & 0xFF);

            if (checkBox21.Checked == true)
                Param.IfTestValidity = 1;
            else
                Param.IfTestValidity = 0;
 
            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.WriteParam(m_hScanner, ref Param, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_WriteParam(m_hSocket, ref Param);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Fail to update rReader parameter!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (checkBox20.Checked == true)
                RS485Address = Convert.ToInt16(textBox34.Text);
            else
                RS485Address = 0;

            int []br=new int[]{9600,19200,38400,57600,115200};
	        int baud=br[Param.BaudRate-4];

            Program.DCB dcb = new Program.DCB();
            Program.GetCommState(m_hScanner, ref dcb);
            dcb.BaudRate = baud;
            Program.SetCommState(m_hScanner, ref dcb);

            Program.PurgeComm(m_hScanner, 0x04);
            Program.PurgeComm(m_hScanner, 0x08);

            switch (ComMode)
            {
                case 0:
                    res = Program.Reboot(m_hScanner, RS485Address);
                    break;
                case 1:
                    res = Program.Net_Reboot(m_hSocket);
                    break;
            }

            if (res == OK)
            {
                MessageBox.Show("Update Reader Parameter successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information );
            }
            else
            {
                MessageBox.Show("Fail to reboot reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }
        public int ReaderParam()
        {
            int i = 0, NumofFreq = 0;
            string strtemp = "";
            double Freq = 0, jumpFreq = 0, temp = 0;
            bool ischina = false, AM = false;
            byte []readerIP =new byte[4];
            byte []mask =new byte[4];
            byte []gateway =new byte[4];
            int port;
            Program.Parameter Param=new Program.Parameter();
            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.ReadParam(m_hScanner, ref Param, RS485Address);
                        break;
                    case 1:
                        res = Program.Net_ReadParam(m_hSocket, ref Param);
                        break;
                }
                if (res == OK)
                    break;
            }

            if (res !=OK)
            {
                MessageBox.Show("Fail to read parameter of reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return res;
            }
            switch (Convert.ToInt16(textBox25.Text) / 100)
            {
                case 20:
                    switch (Convert.ToInt16(textBox26.Text) % 100)
                    {
                        case 0:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                        case 1:
                            NumofFreq = 125;
                            Freq = 902.6;
                            jumpFreq = 0.2;
                            break;
                        case 2:
                            NumofFreq = 11;
                            Freq = 865.6;
                            jumpFreq = 0.2;
                            break;
                        case 3:
                            NumofFreq = 8;
                            Freq = 902.6;
                            jumpFreq = 3.6;
                            break;
                        default:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                    }
                    comboBox18.Items.Add("30ms");
                    comboBox18.Items.Add("50ms");
                    comboBox18.Items.Add("100ms");
                    break;
                case 22:
                    switch (Convert.ToInt16(textBox26.Text) % 100)
                    {
                        case 00:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                        case 01:
                            NumofFreq = 125;
                            Freq = 902.6;
                            jumpFreq = 0.2;
                            break;
                        case 02:
                            NumofFreq = 11;
                            Freq = 865.6;
                            jumpFreq = 0.2;
                            break;
                        case 03:
                            NumofFreq = 8;
                            Freq = 902.6;
                            jumpFreq = 3.6;
                            break;
                        case 04:
                            NumofFreq = 10;
                            Freq = 952.2;
                            jumpFreq = 0.2;
                            break;
                        default:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                    }
                    comboBox18.Items.Add("10ms");
                    comboBox18.Items.Add("30ms");
                    comboBox18.Items.Add("50ms");
                    break;
                case 24:
                    switch (Convert.ToInt16(textBox26.Text) % 100)
                    {
                        case 10:
                            NumofFreq = 8;
                            Freq = 902.6;
                            jumpFreq = 3.6;
                            break;
                        default:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                    }

                    comboBox18.Items.Add("30ms");
                    comboBox18.Items.Add("50ms");
                    comboBox18.Items.Add("100ms");
                    break;
                case 26:
                case 10:
                case 11:
                    switch (Convert.ToInt16(textBox26.Text) % 100)
                    {
                        case 00:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                        case 01:
                            NumofFreq = 125;
                            Freq = 902.6;
                            jumpFreq = 0.2;
                            break;
                        case 02:
                            NumofFreq = 11;
                            Freq = 865.5;
                            jumpFreq = 0.2;
                            break;
                        case 03:
                            NumofFreq = 8;
                            Freq = 902.6;
                            jumpFreq = 3.6;
                            break;
                        case 04:
                            NumofFreq = 10;
                            Freq = 952.2;
                            jumpFreq = 0.2;
                            break;
                        case 05:
                            NumofFreq = 42;
                            Freq = 919.2;
                            jumpFreq = 0.2;
                            break;
                        case 06:
                            NumofFreq = 16;
                            Freq = 920.625;
                            jumpFreq = 0.25;
                            ischina = true;
                            break;
                        //韩国
                        case 07:
                            NumofFreq = 16;
                            Freq = 910.5;
                            jumpFreq = 0.2;
                            break;
                        case 08:
                            NumofFreq = 50;
                            Freq = 902.75;
                            jumpFreq = 0.5;
                            AM = true;
                            break;
                        case 09:
                            NumofFreq = 16;
                            Freq = 840.625;
                            jumpFreq = 0.25;
                            ischina = true;
                            break;
                        default:
                            NumofFreq = 63;
                            Freq = 902.6;
                            jumpFreq = 0.4;
                            break;
                    }
                    comboBox18.Items.Add("10ms");
                    comboBox18.Items.Add("30ms");
                    comboBox18.Items.Add("50ms");
                    break;
            }
            for (i = 0; i < NumofFreq; i++)
            {
                if (ischina)
                {
                    temp = Freq + i * jumpFreq;
                    strtemp = string.Format("{0,0:D}{1,0:s}{2,7:F03}", i + 1, ":", temp);
                }
                else
                {
                    if (AM == true)
                    {
                        temp = Freq + i * jumpFreq;
                        strtemp = string.Format("{0,0:D}{1,0:s}{2,6:F02}", i + 1, ":", temp);

                    }
                    else
                    {
                        temp = Freq + i * jumpFreq;
                        strtemp = String.Format("{0,0:D}{1,0:s}{2,4:F01}", i + 1, ":", temp);
                    }

                }
                comboBox14.Items.Add(strtemp);
                comboBox15.Items.Add(strtemp);
            }

            if ((Param.BaudRate - 4) < 0)
                comboBox13.SelectedIndex = 3;
            else
                comboBox13.SelectedIndex = Param.BaudRate - 4;
            comboBox14.SelectedIndex = Param.Min_Frequence - 1;
            comboBox15.SelectedIndex = Param.Max_Frequence - 1;
            comboBox18.SelectedIndex = Param.ReadInterval;
            textBox27.Text = Param.Power.ToString();
            textBox29.Text = Param.NumofCard.ToString();
            textBox32.Text = Param.StandardTime.ToString();
            textBox31.Text = Param.WiegandWidth.ToString();
            textBox30.Text = Param.WiegandInterval.ToString();
            textBox33.Text = Param.ID_Start.ToString();
            textBox34.Text = Param.ReaderAddress.ToString();
            if (Convert.ToInt16(textBox25.Text) / 100 == 24 || Convert.ToInt16(textBox25.Text) / 100 == 26
                || Convert.ToInt16(textBox25.Text) / 100 == 10 || Convert.ToInt16(textBox25.Text) / 100 == 11)
            { 
                comboBox17.SelectedIndex = Param.ReadDuration & 0x0F;
                comboBox16.SelectedIndex = (Param.ReadDuration & 0xF0) >> 4;
            }
            switch(Param.WorkMode)
            {
                case 0:
                    radioButton29.Checked = true;
                    break;
                case 1:
                    radioButton30.Checked = true;
                    break;
                case 2:
                    radioButton31.Checked = true;
                    break;
            }
            switch (Param.TagType)
            {
                case 1:
                    radioButton36.Checked = true;
                    break;
                case 4:
                    radioButton38.Checked = true;
                    break;
                case 8:
                    radioButton39.Checked = true;
                    break;
            }
            switch (Param.OutMode)
            {
                case 0:
                    radioButton40.Checked = true;
                    break;
                case 1:
                    radioButton41.Checked = true;
                    break;
            }
            switch (Param.OutInterface)
            {
                case 0:
                    radioButton32.Checked = true;
                    break;
                case 1:
                    radioButton33.Checked = true;
                    break;
                case 2:
                    radioButton34.Checked = true;
                    break;
                case 3:
                    radioButton35.Checked = true;
                    break;
                case 4:
                    radioButton37.Checked = true;
                    break;
            }
            if ((Param.EnableBuzzer & 0x01) == 1)
                checkBox13.Checked = true;
            else
                checkBox13.Checked = false;

            if (((Param.EnableBuzzer>>3) & 0x01) == 1)
                checkBox20.Checked = true;
            else
                checkBox20.Checked = false;



            if ((Param.Antenna  & 0x01) == 1)
                checkBox14.Checked = true;
            else
                checkBox14.Checked = false;

            if (((Param.Antenna>>1) & 0x01) == 1)
                checkBox15.Checked = true;
            else
                checkBox15.Checked = false;

            if (((Param.Antenna>>2) & 0x01) == 1)
                checkBox16.Checked = true;
            else
                checkBox16.Checked = false;

            if (((Param.Antenna>>3 )& 0x01) == 1)
                checkBox17.Checked = true;
            else
                checkBox17.Checked = false;

            if (checkBox20.Checked == true)
                RS485Address = Convert.ToInt16(textBox34.Text);
            else
                RS485Address = 0;

            if ((Param.IfTestValidity  & 0x01) == 1)
                checkBox21.Checked = true;
            else
                checkBox21.Checked = false;
            textBox43.Text = Param.HostIP1.ToString();
            textBox43.Text += ".";
            textBox43.Text += Param.HostIP2.ToString();
            textBox43.Text += ".";
            textBox43.Text += Param.HostIP3.ToString();
            textBox43.Text += ".";
            textBox43.Text += Param.HostIP4.ToString();
            port = (int)(Param.HostPort1 << 8) + (int)Param.HostPort2;
            textBox44.Text = port.ToString();
            switch (ComMode)
            {
                case 0:
                    res = Program.GetReaderNetwork(m_hScanner, readerIP, ref port, mask, gateway);
                    break;
                case 1:
                    res = Program.Net_GetReaderNetwork(m_hSocket, readerIP, ref port, mask, gateway);
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("fail to get IP information of reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return res;
            }
            textBox28.Text = readerIP[0].ToString();
            textBox28.Text += ".";
            textBox28.Text += readerIP[1].ToString();
            textBox28.Text += ".";
            textBox28.Text += readerIP[2].ToString();
            textBox28.Text += ".";
            textBox28.Text += readerIP[3].ToString();
            textBox40.Text = port.ToString();
            textBox41.Text = mask[0].ToString();
            textBox41.Text += ".";
            textBox41.Text += mask[1].ToString();
            textBox41.Text += ".";
            textBox41.Text += mask[2].ToString();
            textBox41.Text += ".";
            textBox41.Text += mask[3].ToString();
            textBox42.Text = gateway[0].ToString();
            textBox42.Text += ".";
            textBox42.Text += gateway[1].ToString();
            textBox42.Text += ".";
            textBox42.Text += gateway[2].ToString();
            textBox42.Text += ".";
            textBox42.Text += gateway[3].ToString();

            byte[] ReaderID = new byte[6];
            switch (ComMode)
            {
                case 0:
                    res = Program.GetReaderID(m_hScanner, ReaderID);
                    break;
                case 1:
                    res = Program.Net_GetReaderID(m_hSocket, ReaderID);
                    break;
            }
            textBox39.Text = "";
            for (i = 0; i < 6; i++)
            {
                textBox39.Text += ReaderID[i].ToString("X02");
            }
            return OK;
        }

        private void button25_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int Relay = 0;
            if (checkBox18.Checked == true)
                Relay += 1;
            if (checkBox19.Checked == true)
                Relay += 2;
            switch (ComMode)
            {
                case 0:
                    res = Program.SetRelay(m_hScanner, Relay, RS485Address);
                    break;
                case 1:
                    res = Program.Net_SetRelay(m_hSocket, Relay);
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Set relay unsuccessfully! Please try again!", "Warning",MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else
                MessageBox.Show("Set relay successfully!", "Notice",MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void button26_Click(object sender, EventArgs e)
        {
            int i;
            byte HardVer;
            szPort = comboBox19.Text;
            readerip = textBox35.Text;
            readerport = Convert.ToUInt16(textBox36.Text);
            hostip = textBox37.Text;
            hostport = Convert.ToUInt16(textBox38.Text);
            if (radioButton42.Checked == true)
                ComMode = 1;
            else
                ComMode = 0;
            for (i = 0; i < 3; i++)
            {
                switch(ComMode)
                {
                    case 0:
                        res = Program.ConnectScanner(ref m_hScanner, szPort, nBaudRate);
                        break;
                    case 1:
                        res = Program.Net_ConnectScanner(ref m_hSocket, readerip, readerport, hostip, hostport);
                        //OK;
                        break;
                }
                if (res == OK)
                    break;
            }
            if ((res != OK)&&(ComMode==0))
            {
                MessageBox.Show("None Reader connect to the COM!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if ((res != OK) && (ComMode == 1))
            {
                MessageBox.Show("None Reader connect to the RJ45!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            for (i = 0; i < 3; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.GetReaderVersion(m_hScanner, ref HardVersion, ref SoftVersion, 0);
                        break;
                    case 1:
                        res = Program.Net_GetReaderVersion(m_hSocket, ref HardVersion, ref SoftVersion);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                connect_OK = 0;
                MessageBox.Show("Can't get reader version!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else
            {
                connect_OK = 1;
                MessageBox.Show("Connect reader success!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            }
            HardVer = (byte)HardVersion;
            textBox25.Text = String.Format("{0,0:D02}{1,0:D02}", (byte)(HardVersion >> 8), (byte)HardVersion);
            textBox26.Text = String.Format("{0,0:D02}{1,0:D02}", (byte)(SoftVersion >> 8), (byte)SoftVersion);


            //           str = Convert.ToString(HardVersion, 16);
            //           strtemp = Convert.ToString(SoftVersion, 16);

            if ((HardVer & 0x01) == 1)
            {
                checkBox2.Enabled = false;
                checkBox3.Enabled = false;
                checkBox4.Enabled = false;
                checkBox6.Enabled = false;
                checkBox7.Enabled = false;
                checkBox8.Enabled = false;
                checkBox10.Enabled = false;
                checkBox11.Enabled = false;
                checkBox12.Enabled = false;
                checkBox15.Enabled = false;
                checkBox16.Enabled = false;
                checkBox17.Enabled = false;
            }
            if ((HardVer >> 2 & 0x01) == 1)
            {
                checkBox2.Enabled = true;
                checkBox3.Enabled = false;
                checkBox4.Enabled = false;
                checkBox6.Enabled = true;
                checkBox7.Enabled = false;
                checkBox8.Enabled = false;
                checkBox10.Enabled = true;
                checkBox11.Enabled = false;
                checkBox12.Enabled = false;
                checkBox15.Enabled = true;
                checkBox16.Enabled = false;
                checkBox17.Enabled = false;
            }
            if ((HardVer >> 3 & 0x01) == 1)
            {
                checkBox2.Enabled = true;
                checkBox3.Enabled = true;
                checkBox4.Enabled = true;
                checkBox6.Enabled = true;
                checkBox7.Enabled = true;
                checkBox8.Enabled = true;
                checkBox10.Enabled = true;
                checkBox11.Enabled = true;
                checkBox12.Enabled = true;
                checkBox15.Enabled = true;
                checkBox16.Enabled = true;
                checkBox17.Enabled = true;
            }
            ReaderParam();
            this.tabControl1.SelectedIndex = 1;
        }

        private void button27_Click(object sender, EventArgs e)
        {
            switch (ComMode)
            {
                case 0:
                    Program.DisconnectScanner(m_hScanner);
                    break;
                case 1:
                    Program.Net_DisconnectScanner();
                    break;
            }
        }

        private void listView4_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i;
            for (i = 0; i < 20; i++)
            {
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            Program.ReaderDate time;
            DateTime dt = DateTime.Now;
            time.Year = (byte)((dt.Year - 2000) & 0x00FF);
            time.Month = (byte)dt.Month;
            time.Day = (byte)dt.Day;
            time.Hour = (byte)dt.Hour;
            time.Minute = (byte)dt.Minute;
            time.Second = (byte)dt.Second;
            switch (ComMode)
            {
                case 0:
                    res = Program.SetReaderTime(m_hScanner, time, 0);
                    break;
                case 1:
                    res = Program.Net_SetReaderTime(m_hSocket, time);
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Can't set reader time!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else
            {
                textBox45.Text = "Set reader time successfully!";
            }
         }

        private void button28_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i;
            Program.ReaderDate time = new Program.ReaderDate();
            for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.GetReaderTime(m_hScanner, ref time, 0);
                        break;
                    case 1:
                        res = Program.Net_GetReaderTime(m_hSocket, ref time);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Can't get reader time!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            textBox45.Text = "Reader time is ";
            textBox45.Text += time.Year.ToString("D2");
            textBox45.Text += "-";
            textBox45.Text += time.Month.ToString("D2"); 
            textBox45.Text += "-";
            textBox45.Text += time.Day.ToString("D2"); 
            textBox45.Text += " ";
            textBox45.Text += time.Hour.ToString("D2"); 
            textBox45.Text += ":";
            textBox45.Text += time.Minute.ToString("D2");
            textBox45.Text += ":";
            textBox45.Text += time.Second.ToString("D2");
        }

        private void button29_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            int i,j;
            j = (int)MessageBox.Show("Do you determine to recover the factory parameter?", "Information", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (j != 1)
                return;

           progressBar1.Visible = true;
           progressBar1.Value = 0;
           progressBar1.Step = 20;
           progressBar1.PerformStep();

           for (i = 0; i < 5; i++)
            {
                switch (ComMode)
                {
                    case 0:
                        res = Program.ReadFactoryParameter(m_hScanner);
                        break;
                    case 1:
                        res = Program.Net_ReadFactoryParameter(m_hSocket);
                        break;
                }
                if (res == OK)
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Fail to recover default parameters!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            Thread.Sleep(500);
            progressBar1.PerformStep();
            switch (ComMode)
            {
                case 0:
                    Program.Reboot(m_hScanner,0);
                    break;
                case 1:
                    Program.Net_Reboot(m_hSocket);
                    break;
            }
            if (ComMode == 0)
               Program.DisconnectScanner(m_hScanner);

           Thread.Sleep(500);
           progressBar1.PerformStep();
           if (ComMode == 0)
            {
                for (i = 0; i < 5; i++)
                {
                    Thread.Sleep(100);
                    res = Program.ConnectScanner(ref m_hScanner, szPort, nBaudRate);
                    if (res == OK)
                        break;
                 }
            }
            if (res != OK)
            {
                MessageBox.Show("Can't connect the reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            progressBar1.PerformStep();
            res = ReaderParam();
            if (res != OK)
            {
                progressBar1.Visible = false;
                return;
            }
            progressBar1.Visible = false;
            MessageBox.Show("Set default parameter successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        //Get record from reader
        private void button30_Click(object sender, EventArgs e)
        {
            int i, j, m = 0, n, relistlen=0, recordlen=0, num_8, StrRecord, RecordNum;
	        string DateNo,datas,antno="";
	        byte[] data = new byte[8*64];
            Program.ReaderDate stime = new Program.ReaderDate();
            Program.ReaderDate etime = new Program.ReaderDate();
            string[] dateinfo = new string[6];
            ListViewItem item = new ListViewItem();

            dateinfo = textBox46.Text.Split(new Char[] { '-',':' ,' '});
            stime.Year = Convert.ToByte(dateinfo[0]);
            stime.Month = Convert.ToByte(dateinfo[1]);
            stime.Day = Convert.ToByte(dateinfo[2]);
            stime.Hour = Convert.ToByte(dateinfo[3]);
            stime.Minute = Convert.ToByte(dateinfo[4]);
            stime.Second = Convert.ToByte(dateinfo[5]);
            dateinfo = textBox47.Text.Split(new Char[] { '-', ':', ' ' });
            etime.Year = Convert.ToByte(dateinfo[0]);
            etime.Month = Convert.ToByte(dateinfo[1]);
            etime.Day = Convert.ToByte(dateinfo[2]);
            etime.Hour = Convert.ToByte(dateinfo[3]);
            etime.Minute = Convert.ToByte(dateinfo[4]);
            etime.Second = Convert.ToByte(dateinfo[5]);
            listView5.Items.Clear();
            RecordNum = Convert.ToInt32(textBox49.Text);
            num_8 = RecordNum / 8;
            StrRecord = Convert.ToInt32(textBox48.Text);
	        for(i=0;i<num_8;i++)
	        {
                switch (ComMode)
		        {
		        case 0:
                    res = Program.GetRecord(m_hScanner, ref stime, ref etime, StrRecord + i * 8, 8, ref relistlen, ref recordlen, data);
			        break;
		        case 1:
                    res = Program.Net_GetRecord(m_hSocket, ref stime, ref etime, StrRecord + i * 8, 8, ref relistlen, ref recordlen, data);
			        break;
		        }
		        if(res != OK)
		        {
                    MessageBox.Show("Fail to get record from the reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
		        }
		        if((relistlen == 0)&&(i==0))
		        {
                    MessageBox.Show("There isn't record in the reader!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
		        }
		        for(j=0;j<relistlen;j++)
		        {
                    datas = "";
                    for (n = 0; n < (recordlen - 7); n++)
                    {
                        datas += data[j * recordlen + 6 + n].ToString("X2");
                    }
                    DateNo = data[j * recordlen].ToString("D2") + "-";
                    DateNo += data[j * recordlen + 1].ToString("D2") + "-";
                    DateNo += data[j * recordlen + 2].ToString("D2") + " ";
                    DateNo += data[j * recordlen + 3].ToString("D2") + ":";
                    DateNo += data[j * recordlen + 4].ToString("D2") + ":";
                    DateNo += data[j * recordlen + 5].ToString("D2");
                    switch (data[j * recordlen + recordlen - 1])
			        {
				        case 1:
					        antno = "1";
					        break;
				        case 2:
					        antno = "2";
					        break;
				        case 4:
					        antno = "3";
					        break;
				        case 8:
					        antno = "4";
					        break;
			        }
                    item = listView5.Items.Add((m + 1).ToString(), m);
                    item.SubItems.Add(datas);
                    item.SubItems.Add((recordlen - 7).ToString());
                    item.SubItems.Add(antno);
                    item.SubItems.Add(DateNo);
                    m++;
		        }
		        if(relistlen < 8)
			        return;
	        }
            if ((RecordNum - num_8 * 8) > 0)
	        {
                switch (ComMode)
		        {
		        case 0:
                    res = Program.GetRecord(m_hScanner, ref stime, ref etime, StrRecord + num_8 * 8, RecordNum - num_8 * 8, ref relistlen, ref recordlen, data);
			        break;
		        case 1:
                    res = Program.Net_GetRecord(m_hSocket, ref stime, ref etime, StrRecord + num_8 * 8, RecordNum - num_8 * 8, ref relistlen, ref recordlen, data);
			        break;
		        }
		        if(res != OK)
		        {
                    MessageBox.Show("Fail to get record from the reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
		        }
		        if((relistlen == 0)&&(i==0))
		        {
                    MessageBox.Show("There isn't record in the reader!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
		        }
		        for(j=0;j<relistlen;j++)
		        {
                    datas = "";
                    for (n = 0; n < (recordlen - 7); n++)
                    {
                        datas += data[j * recordlen + 6 + n].ToString("X2");
                    }
                    DateNo = data[j * recordlen].ToString("D2") + "-";
                    DateNo += data[j * recordlen + 1].ToString("D2") + "-";
                    DateNo += data[j * recordlen + 2].ToString("D2") + " ";
                    DateNo += data[j * recordlen + 3].ToString("D2") + ":";
                    DateNo += data[j * recordlen + 4].ToString("D2") + ":";
                    DateNo += data[j * recordlen + 5].ToString("D2");
                    switch (data[j * recordlen + recordlen - 1])
                    {
                        case 1:
                            antno = "1";
                            break;
                        case 2:
                            antno = "2";
                            break;
                        case 4:
                            antno = "3";
                            break;
                        case 8:
                            antno = "4";
                            break;
                    }
                    item = listView5.Items.Add((m + 1).ToString(), m);
                    item.SubItems.Add(datas);
                    item.SubItems.Add((recordlen - 7).ToString());
                    item.SubItems.Add(antno);
                    item.SubItems.Add(DateNo);
                    m++;
                }
	        }
        }

        //delete record of reader
        private void button31_Click(object sender, EventArgs e)
        {
            switch (ComMode)
            {
                case 0:
                    res = Program.DeleteAllRecord(m_hScanner);
                    break;
                case 1:
                    res = Program.Net_DeleteAllRecord(m_hSocket);
                    break;
            }
            if (res != OK)
            {
                MessageBox.Show("Fail to delete records in the reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
        }

        //Get user list from PC
        private void button32_Click(object sender, EventArgs e)
        {
            int i, j=0, num, strlen;
            string DataNo, datas, str;
            ListViewItem item = new ListViewItem();
            StreamReader sr = File.OpenText("LableDataBase.txt"); ;
            num = Convert.ToInt32(sr.ReadLine());
            listView5.Items.Clear();
            for (i = 0; i < num; i++)
            {
                DataNo = "ID" + (i + 1).ToString("D");
                datas = sr.ReadLine();
                if (datas == null)
                    continue;
                item = listView5.Items.Add((j + 1).ToString(), j);
                item.SubItems.Add(datas);
                strlen = datas.Length >> 1;
                item.SubItems.Add(strlen.ToString());
                j++;
            }
            sr.Close();
        }

        //Set user list to PC
        private void button33_Click(object sender, EventArgs e)
        {
            int j=0;
            string str_temp = "";
            FileStream fs = new FileStream("LableDataBase.txt", FileMode.OpenOrCreate, FileAccess.Write, FileShare.Read);
            StreamWriter sw = new StreamWriter(fs);

            str_temp = listView5.Items.Count.ToString();
            sw.WriteLine(str_temp);
            for (j = 0; j < listView5.Items.Count; j++)
            {
                str_temp = listView5.Items[j].SubItems[1].Text;
                sw.WriteLine(str_temp);
            }
            sw.Close();
        }

       //Get user list from reader 
        private void button34_Click(object sender, EventArgs e)
        {
	        int i,j,m=0,n,idlen=0,listl=0,straddr=1,total;
	        string datas;
	        byte[] data = new byte[8*64];
            ListViewItem item = new ListViewItem();

            listView5.Items.Clear();
            j = 0;
	        total=1;
	        do
	        {
                switch (ComMode)
		        {
		        case 0:
                    res = Program.GetLableID(m_hScanner, straddr + j * 8, 8, ref listl, ref idlen, data);
			        break;
		        case 1:
			        res = Program.Net_GetLableID(m_hSocket, straddr+j*8, 8, ref listl, ref idlen, data);
			        break;
		        }
		        if(res != OK)
		        {
                    MessageBox.Show("Fail to get user list from the reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
			        return;
		        }
                j++;
		        for(i=0;i<listl;i++)
		        {
                    datas = "";
                    for (n = 0; n < idlen; n++)
                    {
                        datas += data[i * idlen + n].ToString("X2");
                    }
                    item = listView5.Items.Add((m + 1).ToString(), m);
                    item.SubItems.Add(datas);
                    item.SubItems.Add(idlen.ToString());
			        m++;
			        total++;
		        }
	        }
	        while(listl == 8);
        }

        //Set user list to reader
        private void button35_Click(object sender, EventArgs e)
        {
	        int i,j,m,n,strlen,total;
            byte[] data = new byte[8 * 64];
            byte[] temp = new byte[32];
	        string str_temp,str;
            int st1, st2;
            byte stt;
            ListViewItem item = new ListViewItem();

            j = 0;
	        total = 0;
            m = listView5.Items.Count;
            for (i = 0; i < m; i++)
	        {
                str_temp = listView5.Items[i].SubItems[1].Text;
                strlen = str_temp.Length>>1;
                for (n = 0; n < strlen; n++)
                {
                    if (str_temp[2 * n] > 64)
                        st1 = str_temp[2 * n] - 55;
                    else
                        st1 = str_temp[2 * n] - 48;
                    if (str_temp[2 * n + 1] > 64)
                        st2 = str_temp[2 * n + 1] - 55;
                    else
                        st2 = str_temp[2 * n + 1] - 48;

                    data[j * strlen + n] = Convert.ToByte(st1*16 + st2);
                }
		        j++;
		        total ++;
		        if(j == 8)
		        {
                    switch (ComMode)
			        {
			        case 0:
                        res = Program.AddLableID(m_hScanner, j, strlen, data);
				        break;
			        case 1:
                        res = Program.Net_AddLableID(m_hSocket, j, strlen, data);
				        break;
			        }
			        if(res != OK)
			        {
                        MessageBox.Show("Fail to add user list to reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
				        return;
			        }
			        j=0;
		        }
		        if((total == m)&&(j != 0))
		        {
                    switch (ComMode)
			        {
			        case 0:
                       res = Program.AddLableID(m_hScanner, j, strlen, data);
				        break;
			        case 1:
                       res = Program.Net_AddLableID(m_hSocket, j, strlen, data);
				        break;
			        }
			        if(res != OK)
			        {
                        MessageBox.Show("Fail to add user list to reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
				        return;
			        }
		        }
	        }
            MessageBox.Show("Add user list to reader successfully!", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        //Delete user list of reader
        private void button36_Click(object sender, EventArgs e)
        {
	        byte[] data = new byte[8*64];
            switch (ComMode)
	        {
	        case 0:
                res = Program.DelLableID(m_hScanner, 0, 8, data);
		        break;
	        case 1:
                res = Program.Net_DelLableID(m_hSocket, 0, 8, data);
		        break;
	        }
	        if(res != OK)
	        {
                MessageBox.Show("Fail to delete user list of reader!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
	        }
        }

        //Identify 6C tag 
        private void button37_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            nidEvent = 12;
            int i;
            Interval = 50;
            if (button37.Text == "Identify 6C EPC")
            {
                for (i = 0; i < 3; i++)
                {
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.SetAntenna(m_hScanner, 1, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_SetAntenna(m_hSocket, 1);
                            break;
                    }
                    if (res == OK)
                        break;
                }
                if (res != 0)
                {
                    MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    button37.Text = "Identify 6C EPC";
                    return;
                }
                button37.Text = "Stop";
                k = 0;
                listView5.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button37.Text = "Identify 6C EPC";
                timer1.Enabled = false;
            }
        }

        //Identify 6B tag 
        private void button38_Click(object sender, EventArgs e)
        {
            if (connect_OK == 0)
                return;
            nidEvent = 13;
            int i;
            Interval = 50;
            if (button38.Text == "Identify 6B ID")
            {
                for (i = 0; i < 3; i++)
                {
                    switch (ComMode)
                    {
                        case 0:
                            res = Program.SetAntenna(m_hScanner, 1, RS485Address);
                            break;
                        case 1:
                            res = Program.Net_SetAntenna(m_hSocket, 1);
                            break;
                    }
                    if (res == OK)
                        break;
                }
                if (res != 0)
                {
                    MessageBox.Show("Fail to set antenna! Please try again!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    button37.Text = "Identify 6B ID";
                    return;
                }
                button38.Text = "Stop";
                k = 0;
                listView5.Items.Clear();
                timer1.Interval = Interval;
                timer1.Enabled = true;
            }
            else
            {
                button38.Text = "Identify 6B ID";
                timer1.Enabled = false;
            }

        }


     }
}