// EPCC1G2Test.cpp : implementation file
//

#include "stdafx.h"
#include "ReaderDemo.h"
#include "EPCC1G2Test.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BYTE EPCC1G2_IDBuffer[MAX_LABELS][ID_MAX_SIZE_96BIT];
/////////////////////////////////////////////////////////////////////////////
// CEPCC1G2Test property page

IMPLEMENT_DYNCREATE(CEPCC1G2Test, CPropertyPage)

CEPCC1G2Test::CEPCC1G2Test() : CPropertyPage(CEPCC1G2Test::IDD)
{
	//{{AFX_DATA_INIT(CEPCC1G2Test)
	m_Antenna1 = TRUE;
	m_Antenna2 = FALSE;
	m_Antenna3 = FALSE;
	m_Antenna4 = FALSE;
	m_mem = 1;
	m_LAddress = 0;
	m_LLen = 0;
	m_LData = _T("");
	m_ListTagID = FALSE;
	m_RWAddress = 0;
	m_RWLen = 1;
	m_ReadDataBlock = FALSE;
	m_Condition = 0;
	m_Password = 0;
	m_LAccessPassword = _T("");
	m_RWAccessPassword = _T("");
	m_Condition2 = 0;
	m_RWmem = 1;
	m_Lmem = 1;
	m_Data = _T("");
	m_KillPassword = _T("");
	m_LBAddress = 0;
	m_LBAccessPassword = _T("");
	m_EasState = 0;
	m_AAccessPassword = _T("");
	m_EasAlarm = FALSE;
	m_RProtectPassword = _T("");
	m_KPassword = _T("");
	m_Kword = FALSE;
	m_DetectTag = FALSE;
	//}}AFX_DATA_INIT
}

CEPCC1G2Test::~CEPCC1G2Test()
{
}

void CEPCC1G2Test::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEPCC1G2Test)
	DDX_Control(pDX, IDC_COMBO7, m_PTagID);
	DDX_Control(pDX, IDC_EASALARM_STATIC, m_APic);
	DDX_Control(pDX, IDC_COMBO6, m_ATagID);
	DDX_Control(pDX, IDC_COMBO5, m_LBTagID);
	DDX_Control(pDX, IDC_COMBO4, m_KTagID);
	DDX_Control(pDX, IDC_COMBO3, m_LTagID);
	DDX_Control(pDX, IDC_LIST2, m_ListData);
	DDX_Control(pDX, IDC_COMBO1, m_TagID);
	DDX_Control(pDX, IDC_COMBO2, m_Interval);
	DDX_Control(pDX, IDC_LIST1, m_ListID);
	DDX_Check(pDX, IDC_CHECK1, m_Antenna1);
	DDX_Check(pDX, IDC_CHECK2, m_Antenna2);
	DDX_Check(pDX, IDC_CHECK3, m_Antenna3);
	DDX_Check(pDX, IDC_CHECK4, m_Antenna4);
	DDX_Radio(pDX, IDC_RADIO1, m_mem);
	DDX_Text(pDX, IDC_EDIT1, m_LAddress);
	DDX_Text(pDX, IDC_EDIT2, m_LLen);
	DDX_Text(pDX, IDC_EDIT3, m_LData);
	DDX_Check(pDX, IDC_CHECK5, m_ListTagID);
	DDX_Text(pDX, IDC_EDIT4, m_RWAddress);
	DDX_Text(pDX, IDC_EDIT5, m_RWLen);
	DDX_Check(pDX, IDC_CHECK6, m_ReadDataBlock);
	DDX_Radio(pDX, IDC_RADIO9, m_Password);
	DDX_Text(pDX, IDC_EDIT10, m_LAccessPassword);
	DDV_MaxChars(pDX, m_LAccessPassword, 8);
	DDX_Text(pDX, IDC_EDIT11, m_RWAccessPassword);
	DDV_MaxChars(pDX, m_RWAccessPassword, 8);
	DDX_Radio(pDX, IDC_RADIO11, m_Condition2);
	DDX_Radio(pDX, IDC_RADIO15, m_RWmem);
	DDX_Radio(pDX, IDC_RADIO19, m_Lmem);
	DDX_Text(pDX, IDC_EDIT6, m_Data);
	DDX_Text(pDX, IDC_EDIT9, m_KillPassword);
	DDV_MaxChars(pDX, m_KillPassword, 8);
	DDX_Text(pDX, IDC_EDIT7, m_LBAddress);
	DDX_Text(pDX, IDC_EDIT8, m_LBAccessPassword);
	DDV_MaxChars(pDX, m_LBAccessPassword, 8);
	DDX_Radio(pDX, IDC_RADIO23, m_EasState);
	DDX_Text(pDX, IDC_EDIT12, m_AAccessPassword);
	DDV_MaxChars(pDX, m_AAccessPassword, 8);
	DDX_Check(pDX, IDC_CHECK7, m_EasAlarm);
	DDX_Text(pDX, IDC_EDIT13, m_RProtectPassword);
	DDV_MaxChars(pDX, m_RProtectPassword, 8);
	DDX_Text(pDX, IDC_EDIT14, m_KPassword);
	DDV_MaxChars(pDX, m_KPassword, 8);
	DDX_Check(pDX, IDC_CHECK9, m_Kword);
	DDX_Check(pDX, IDC_CHECK10, m_DetectTag);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEPCC1G2Test, CPropertyPage)
	//{{AFX_MSG_MAP(CEPCC1G2Test)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_RADIO19, OnRadio19)
	ON_BN_CLICKED(IDC_RADIO20, OnRadio20)
	ON_BN_CLICKED(IDC_RADIO21, OnRadio21)
	ON_BN_CLICKED(IDC_RADIO22, OnRadio22)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEPCC1G2Test message handlers

BOOL CEPCC1G2Test::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	DWORD dwStyle = m_ListID.SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE);
	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	m_ListID.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM)dwStyle);

	m_ListID.InsertColumn(0, "No.", LVCFMT_LEFT, 50);
	m_ListID.InsertColumn(1, "ID", LVCFMT_LEFT, 300);
	m_ListID.InsertColumn(2, "Success", LVCFMT_LEFT, 75);
	m_ListID.InsertColumn(3, "Times", LVCFMT_LEFT, 75);
	m_ListID.InsertColumn(4, "EPC Length", LVCFMT_LEFT, 75);

	m_Interval.SetCurSel(3);
	m_RWAccessPassword="00000000";
	m_LAccessPassword="00000000";
	m_LBAccessPassword="00000000";
	m_AAccessPassword="00000000";
	m_KillPassword="00000000";
	m_RProtectPassword="00000000";
	m_KPassword="00000000";

	UpdateData(FALSE);

	OpenPassword=FALSE;
	UpdateStatus();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEPCC1G2Test::OnTimer(UINT nIDEvent) 
{
	apiReturn res;
	BYTE be_antenna;
	int i,j,k,nCounter=0,ID_len=0,ID_len_temp=0;
	CString str,str_temp;
	char temp[64];
	BYTE DB[128];
	BYTE IDBuffer[30*256];

	Read_times++;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		break;
	case 3:
	case 5:
	case 9:
		switch (Read_times%2)
		{
		case 0:
			be_antenna=m_antenna_sel-1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;
	
	case 6:
	case 10:
		switch (Read_times%2)
		{
		case 0:
			be_antenna=m_antenna_sel-2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;

	case 12:
		switch (Read_times%2)
		{
		case 0:
			be_antenna=m_antenna_sel-4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;
	
	case 7:
		switch (Read_times%3)
		{
		case 0:
			be_antenna=4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 2:
			be_antenna=2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;

	case 11:
		switch (Read_times%3)
		{
		case 0:
			be_antenna=8;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 2:
			be_antenna=2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;

	case 13:
		switch (Read_times%3)
		{
		case 0:
			be_antenna=8;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 2:
			be_antenna=4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;

	case 14:
		switch (Read_times%3)
		{
		case 0:
			be_antenna=8;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 2:
			be_antenna=4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;

	case 15:
		switch (Read_times%4)
		{
		case 0:
			be_antenna=8;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 1:
			be_antenna=1;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 2:
			be_antenna=2;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		case 3:
			be_antenna=4;
			switch(ConnectMode)
			{
			case 0:
				Net_SetAntenna(m_hSocket, be_antenna);
				break;
			case 1:
				SetAntenna(m_hScanner, be_antenna,RS485Address);
				break;
			}
			break;
		}
		break;
	}

	switch(nIDEvent)
	{
	case 1:
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_ReadLabelID(m_hSocket,mem,ptr,len,mask,IDBuffer,&nCounter);
			break;
		case 1:
			res=EPC1G2_ReadLabelID(m_hScanner,mem,ptr,len,mask,IDBuffer,&nCounter,RS485Address);
			break;
		}
		k=m_ListID.GetItemCount();
		if (res==_OK)
		{
			for(i=0;i<nCounter;i++)
			{
				if (IDBuffer[ID_len]>32)
				{
					nCounter=0;
					break;
				}
				ID_len_temp=IDBuffer[ID_len]*2+1;//1word=16bit
				memcpy(EPCC1G2_IDBuffer[i], &IDBuffer[ID_len], ID_len_temp);
				ID_len+=ID_len_temp;
			}
			if (nCounter>0)
			{
				MessageBeep(-1);
			}

			for(i=0;i<nCounter;i++)
			{
				str="";
				ID_len=EPCC1G2_IDBuffer[i][0]*2;
				for(j=0;j<ID_len;j++)
				{
					wsprintf(temp, "%02X", *(BYTE *)&EPCC1G2_IDBuffer[i][j+1]);
					str += temp;
				}
				for(j=0;j<k;j++)
				{
					m_ListID.GetItemText(j,4,temp,3);
//					ID_len_temp=strtol(temp,NULL,10)*2;
					ID_len_temp=((BYTE)strtol(temp,NULL,16))*2;
					if (ID_len == ID_len_temp)
					{
						m_ListID.GetItemText(j,1,temp,ID_len*2+1);
						str_temp=temp;
						if(str == str_temp) break;
					}
				}
				if(j == k)
				{
					m_ListID.InsertItem(k,itoa(k+1,temp,10));
					m_ListID.SetItemText(k,1,str);
					m_ListID.SetItemText(k,2,"1");
					str_temp.Format("%02X",EPCC1G2_IDBuffer[i][0]);
					m_ListID.SetItemText(k,4,str_temp);
					m_ListID.EnsureVisible(k,TRUE);
					k++;
				}
				else
				{
					str_temp=m_ListID.GetItemText(j,2);
					m_ListID.SetItemText(j,2,itoa(atoi(str_temp)+1,temp,10));
				}
			}
		}
		for(i=0;i<k;i++)
			m_ListID.SetItemText(i,3,itoa(Read_times,temp,10));
		break;

	case 2:
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_ReadWordBlock(m_hSocket,EPC_Word,IDTemp,mem,ptr,len,&DB[0],AccessPassword);
			break;
		case 1:
			res=EPC1G2_ReadWordBlock(m_hScanner,EPC_Word,IDTemp,mem,ptr,len,&DB[0],AccessPassword,RS485Address);
			break;
		}
		if (res==_OK)
		{
			str="";
			for(i=0;i<len*2;i++)
			{
				str_temp.Format("%02X",DB[i]);
				str+=str_temp;
			}
			m_ListData.AddString(str);
			//m_ListData.SetCurSel(m_ListData.GetCount()-1);
		}
		else
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="Read Fail!";
			m_ListData.AddString(str);
		}

		m_ListData.SetCurSel(m_ListData.GetCount()-1);

		break;

	case 3:
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_EasAlarm(m_hSocket);		
			break;
		case 1:
			res=EPC1G2_EasAlarm(m_hScanner,RS485Address);		
			break;
		}
		if(res==_OK)
		{
			MessageBeep(-1);
			m_APic.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON1));
		}

		Sleep(100);
		m_APic.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON2));
		break;
	case 4:
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_DetectTag(m_hSocket);
			break;
		case 1:
			res=EPC1G2_DetectTag(m_hScanner,RS485Address);
			break;
		}
		k=m_ListID.GetItemCount();
		switch(res)
		{
		case _OK:
			str="There are Tags in the field!";
			Detect++;
			break;
//		case 0x02:
//			str="There is none of Tag in the field!";
//			break;
		case 0x0E:
			str="There are Locked Tags in the field!";
			break;
		}
/*		for(j=0;j<k;j++)
		{
			str_temp=m_ListID.GetItemText(j,1);
		    if(str == str_temp) break;
		}
		if(j== k)
		{
			m_ListID.InsertItem(k,itoa(k+1,temp,10));
			m_ListID.SetItemText(k,1,str);
			m_ListID.SetItemText(k,2,"1");
			m_ListID.EnsureVisible(k,TRUE);
			k++;
		}
		else
		{
			str_temp=m_ListID.GetItemText(j,2);
			m_ListID.SetItemText(j,2,itoa(atoi(str_temp)+1,temp,10));
		}
		if(res==_OK||res==0x0E)
		{
			KillTimer(4);
			m_DetectTag=FALSE;
			UpdateData(FALSE);
		}
*/
//		str_temp=m_ListID.GetItemText(j,1);
		if(3000>=Read_times*timer_interval)
		{
			if(res==0x0E)
			{
				m_ListID.InsertItem(k,itoa(k+1,temp,10));
				m_ListID.SetItemText(k,1,str);
				m_ListID.EnsureVisible(k,TRUE);
				k++;
				KillTimer(4);
				m_DetectTag=FALSE;
				UpdateData(FALSE);
			}
		}
		else
		{
			m_ListID.InsertItem(k,itoa(k+1,temp,10));
			if(Detect==0)
			{
				m_ListID.SetItemText(k,1,"There is none of Tag in the field!");
				m_ListID.EnsureVisible(k,TRUE);
			}
			else
			{
				m_ListID.SetItemText(k,1,"There are Tags in the field!");
				m_ListID.EnsureVisible(k,TRUE);
			}
			k++;
			KillTimer(4);
			m_DetectTag=FALSE;
			UpdateData(FALSE);
		}
		UpdateStatus();
		break;
	}
	
	CPropertyPage::OnTimer(nIDEvent);
}

void CEPCC1G2Test::UpdateStatus()
{
	switch(m_HardVersion & 0xFF)
	{
	case 0x0B:
		GetDlgItem(IDC_CHECK1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm&& !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK2)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK3)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK4)->EnableWindow(FALSE);
		break;
	case 0x0C:
		GetDlgItem(IDC_CHECK1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK3)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK4)->EnableWindow(FALSE);
		break;
	case 0x0E:
		GetDlgItem(IDC_CHECK1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK3)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		GetDlgItem(IDC_CHECK4)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
		break;
	default:
		GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK2)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK3)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK4)->EnableWindow(FALSE);
	}

	GetDlgItem(IDC_BUTTON1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON3)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON5)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON6)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_BUTTON7)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);

	GetDlgItem(IDC_CHECK5)->EnableWindow(ifConnectReader && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_CHECK6)->EnableWindow(ifConnectReader && !m_ListTagID && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_CHECK7)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_CHECK9)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag);
	GetDlgItem(IDC_CHECK10)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_Kword);

	GetDlgItem(IDC_COMBO1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO3)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO4)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO5)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO6)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_COMBO7)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);

	GetDlgItem(IDC_EDIT1)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT3)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT4)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT5)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT6)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT7)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT8)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT9)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT10)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT11)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT12)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT13)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_EDIT14)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);

	//GetDlgItem(IDC_RADIO1)->EnableWindow(!m_ListTagID && !m_ReadDataBlock && !m_EasAlarm);
	GetDlgItem(IDC_RADIO2)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO3)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO6)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO7)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO8)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO9)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO10)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO11)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO12)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO13)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO14)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !OpenPassword && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO15)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO16)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO17)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO18)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO19)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO20)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO21)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO22)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO23)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
	GetDlgItem(IDC_RADIO24)->EnableWindow(ifConnectReader && !m_ListTagID && !m_ReadDataBlock && !m_EasAlarm && !m_DetectTag && !m_Kword);
}

CString CEPCC1G2Test::ReportError(USHORT res)
{
	CString str;
	switch (res)
	{
	case 0x01:
		str="Connect antenna fail!";
		break;
	case 0x02:
		str="No Tag!";
		break;
	case 0x03:
		str="Illegal Tag!";
		break;
	case 0x04:
		str="Power is not enough!";
		break;
	case 0x05:
		str="The memory has been protected!";
		break;
	case 0x06:
		str="Check sum error!";
		break;
	case 0x07:
		str="Parameter error!";
		break;
	case 0x08:
		str="The memory don't exist!";
		break;
	case 0x09:
		str="The Access Password is error!";
		break;
	case 0x0A:
		str="The Kill Password cannot be 000000!";
		break;
	case 0x0E:
		str="Locked Tags in the field!";
		break;
	case 0x1E:
		str="Invalid Command!";
		break;
	case 0x1F:
		str="Other Error!";
		break;
	default:
		str="Unbeknown Error!";
	}

	return str;
}

void CEPCC1G2Test::OnCheck5() 
{
	apiReturn res;
	UpdateData(TRUE);
	CString str;

	if ((m_LAddress<0) || (m_LAddress>2047))
	{
		MessageBox("Please input Location of Tag Address between 0 and 2047!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT1)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT1))->SetSel(0,-1);
		m_ListTagID=FALSE;
		UpdateData(FALSE);
		return;
	}

	if ((m_LLen<0) || (m_LLen>2048))
	{
		MessageBox("Please input Length of Tag Data between 0 and 2048!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT2)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT2))->SetSel(0,-1);
		m_ListTagID=FALSE;
		UpdateData(FALSE);
		return;
	}

	str=m_LData.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_LData))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT3)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT3))->SetSel(0,-1);
		m_ListTagID=FALSE;
		UpdateData(FALSE);
		return;
	}
	int str_len=strlen(m_LData);
	str=m_LData;
	int i,m;

	if (m_LLen==0)
		m=0;
	else
	{
		m=m_LLen/8;
		if (m_LLen%8!=0)
		{
			for(i=0;i<((m+1)*2-str_len);i++)
				str+="0";
			m++;
		}
	}
	/*if ((str_len*4)<m_LLen)
	{
		for(i=0;i<(m_LLen*2-str_len);i++)
			str+="0";
		MessageBox("Please input enough length tag data!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT3)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT3))->SetSel(0,-1);
		m_ListTagID=FALSE;
		UpdateData(FALSE);
		return;
	}*/

	mem=m_mem;
	ptr=m_LAddress;
	len=m_LLen;

	for(i=0;i<m;i++)
	{
		mask[i]=(BYTE)strtol(((CString)str[i*2]+(CString)str[i*2+1]),NULL,16);
	}

	int interval[]={10,20,30,50,100,200,500};
	timer_interval=interval[m_Interval.GetCurSel()];
	if (m_ListTagID)
	{
		m_antenna_sel=0;
		if(m_Antenna1)
		m_antenna_sel += 1;
		if(m_Antenna2)
		m_antenna_sel += 2;
		if(m_Antenna3)
		m_antenna_sel += 4;
		if(m_Antenna4)
		m_antenna_sel += 8;
		switch(m_antenna_sel)
		{
		case 0:
			MessageBox("Please choose one antenna at least!","Warning",MB_ICONWARNING);
			m_ListTagID=FALSE;
			UpdateData(FALSE);
			return;
			break;
		case 1:
		case 2:
		case 4:
		case 8:
			switch(ConnectMode)
			{
			case 0:
				res = Net_SetAntenna(m_hSocket, m_antenna_sel);
				break;
			case 1:
				res = SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
				break;
			}
			if (res!=_OK)
			{
				MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
				m_ListTagID=FALSE;
				UpdateData(FALSE);
				return;
			}
			break;
		}

		m_ListID.DeleteAllItems();
		Read_times=0;
		UpdateStatus();
		SetTimer(1,timer_interval,NULL);
	}
	else
	{
		KillTimer(1);
		UpdateStatus();

		m_TagID.ResetContent();
		m_LTagID.ResetContent();
		m_KTagID.ResetContent();
		m_LBTagID.ResetContent();
		m_ATagID.ResetContent();
		m_PTagID.ResetContent();

		int k=m_ListID.GetItemCount();
		CString str;
		char temp[64];
		int ID_len;

		for(i=0;i<k;i++)
		{
			m_ListID.GetItemText(i,4,temp,3);
			EPCC1G2_IDBuffer[i][0]=(BYTE)strtol(temp,NULL,16);
			ID_len=EPCC1G2_IDBuffer[i][0]*2;

			str="";
			m_ListID.GetItemText(i,1,temp,ID_len*2+1);

			for(int j=0;j<ID_len;j++)
			{
				EPCC1G2_IDBuffer[i][j+1]=(BYTE)strtol((CString)temp[j*2]+(CString)temp[j*2+1],NULL,16);
			}

			str.Format("%02d.",i+1);
			str+=temp;
			m_TagID.AddString(str);
			m_LTagID.AddString(str);
			m_KTagID.AddString(str);
			m_LBTagID.AddString(str);
			m_ATagID.AddString(str);
			m_PTagID.AddString(str);
		}

		m_TagID.SetCurSel(0);
		m_LTagID.SetCurSel(0);
		m_KTagID.SetCurSel(0);
		m_LBTagID.SetCurSel(0);
		m_ATagID.SetCurSel(0);
		m_PTagID.SetCurSel(0);
	}
}

void CEPCC1G2Test::OnCheck6() 
{
	apiReturn res;
	CString str;
	int i,str_len;
	UpdateData(TRUE);

	if (m_TagID.GetCount()<1)
	{
		MessageBox("Please read first than choose a tag!","Warning",MB_ICONWARNING);
		m_ReadDataBlock=FALSE;
		UpdateData(FALSE);
		return;
	}

	if (m_RWAddress<0)
	{
		MessageBox("Please input Location of Tag Address more then 0!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT4)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT4))->SetSel(0,-1);
		m_ReadDataBlock=FALSE;
		UpdateData(FALSE);
		return;
	}

	if (m_RWLen<1)
	{
		MessageBox("Please input Length of Tag Data more than 1!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT5)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT5))->SetSel(0,-1);
		m_ReadDataBlock=FALSE;
		UpdateData(FALSE);
		return;
	}

	str=m_RWAccessPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_RWAccessPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT11)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT11))->SetSel(0,-1);
		return;
	}
	str=m_RWAccessPassword;
	str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of AccessPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}
	
	mem=m_RWmem;
	ptr=m_RWAddress;
	len=m_RWLen;

	int CurSel=m_TagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	int interval[]={10,20,30,50,100,200,500};
	timer_interval=interval[m_Interval.GetCurSel()];
	if (m_ReadDataBlock)
	{
		m_antenna_sel=0;
		if(m_Antenna1)
		m_antenna_sel += 1;
		if(m_Antenna2)
		m_antenna_sel += 2;
		if(m_Antenna3)
		m_antenna_sel += 4;
		if(m_Antenna4)
		m_antenna_sel += 8;
		switch(m_antenna_sel)
		{
		case 0:
			MessageBox("Please choose one antenna at least!","Warning",MB_ICONWARNING);
			m_ReadDataBlock=FALSE;
			UpdateData(FALSE);
			return;
			break;
		case 1:
		case 2:
		case 4:
		case 8:
			switch(ConnectMode)
			{
			case 0:
				res=Net_SetAntenna(m_hSocket, m_antenna_sel);
				break;
			case 1:
				res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
				break;
			}
			if (res!=_OK)
			{
				MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
				m_ReadDataBlock=FALSE;
				UpdateData(FALSE);
				return;
			}
			break;
		}

		m_ListData.ResetContent();
		Read_times=0;
		UpdateStatus();
		SetTimer(2,timer_interval,NULL);
	}
	else
	{
		KillTimer(2);
		UpdateStatus();

		int dx=0;   
		CSize sz;    
		CDC*  pDC=m_ListData.GetDC();    
		for(i=0;i<m_ListData.GetCount();i++)   
		{   
			m_ListData.GetText(i,str);     
			sz=pDC->GetTextExtent(str);    
			if(sz.cx>dx)      
			dx=sz.cx;      
		}   
		m_ListData.ReleaseDC(pDC);   

		m_ListData.SetHorizontalExtent(dx);
	}
}

void CEPCC1G2Test::OnButton4() 
{
	apiReturn res;
	CString str;
	int i,str_len;

	UpdateData(TRUE);
	m_ListData.ResetContent();

	mem=m_RWmem;
	switch(mem)
	{
	case 0x00:
		if ((m_RWLen<1) || (m_RWLen>4))
		{
			MessageBox("Please input Length of Tag Data between 1 and 4 Word!","Warning",MB_ICONWARNING);
			GetDlgItem(IDC_EDIT5)->SetFocus();
			((CEdit *) GetDlgItem(IDC_EDIT5))->SetSel(0,-1);
			UpdateData(FALSE);
			return;
		}
		break;
	case 0x02:
		if ((m_RWLen<1) || (m_RWLen>8))
		{
			MessageBox("Please input Length of Tag Data between 1 and 8 Word!","Warning",MB_ICONWARNING);
			GetDlgItem(IDC_EDIT5)->SetFocus();
			((CEdit *) GetDlgItem(IDC_EDIT5))->SetSel(0,-1);
			UpdateData(FALSE);
			return;
		}
		break;
	case 0x01:
		if ((m_RWLen<1) || (m_RWLen>32))
		{
			MessageBox("Please input Length of Tag Data between 1 and 32 Word!","Warning",MB_ICONWARNING);
			GetDlgItem(IDC_EDIT5)->SetFocus();
			((CEdit *) GetDlgItem(IDC_EDIT5))->SetSel(0,-1);
			UpdateData(FALSE);
			return;
		}
		break;
	case 0x03:
		if ((m_RWLen<1) || (m_RWLen>128))
		{
			MessageBox("Please input Length of Tag Data between 1 and 128 Word!","Warning",MB_ICONWARNING);
			GetDlgItem(IDC_EDIT5)->SetFocus();
			((CEdit *) GetDlgItem(IDC_EDIT5))->SetSel(0,-1);
			UpdateData(FALSE);
			return;
		}
		break;
	}
	len=m_RWLen;

	str=m_Data.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_Data))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT6)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT6))->SetSel(0,-1);
		return;
	}
	str=m_Data;
	str_len=strlen(str);
	if ((str_len==0) || (str_len/4<len))
	{
		MessageBox("Please input enough Length of Tag Data!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<(len*2);i++)
	{
		mask[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	str=m_RWAccessPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_RWAccessPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT11)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT11))->SetSel(0,-1);
		return;
	}
	str=m_RWAccessPassword;
	str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of AccessPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}

	if (mem==1)
	{
		for(i=0;i<5;i++)
		{
			Sleep(30);
			switch(ConnectMode)
			{
			case 0:
				res = Net_EPC1G2_WriteEPC(m_hSocket,len,&mask[0],AccessPassword);		
				break;
			case 1:
				res = EPC1G2_WriteEPC(m_hScanner,len,&mask[0],AccessPassword,RS485Address);		
				break;
			}
			if ((res==_OK) || (res==_write_prot_error) || (res==_memory_error) || (res==_password_error))
				break;
		}
	}
	else
	{
		if (m_TagID.GetCount()<1)
		{
			MessageBox("Please read first then choose a tag!","Warning",MB_ICONWARNING);
			UpdateData(FALSE);
			return;
		}

		switch(mem)
		{
		case 0x00:
			if ((m_RWAddress<0) || (m_RWAddress>3))
			{
				MessageBox("Please input Location of Tag Address between 0 and 3!","Warning",MB_ICONWARNING);
				GetDlgItem(IDC_EDIT4)->SetFocus();
				((CEdit *) GetDlgItem(IDC_EDIT4))->SetSel(0,-1);
				UpdateData(FALSE);
				return;
			}
			if ((m_RWAddress+m_RWLen)>4)
			{
				m_RWLen=4-m_RWAddress;
				UpdateData(FALSE);
				len=4-m_RWAddress;
			}
			break;
		case 0x02:
			if ((m_RWAddress<0) || (m_RWAddress>7))
			{
				MessageBox("Please input Location of Tag Address between 0 and 7!","Warning",MB_ICONWARNING);
				GetDlgItem(IDC_EDIT4)->SetFocus();
				((CEdit *) GetDlgItem(IDC_EDIT4))->SetSel(0,-1);
				UpdateData(FALSE);
				return;
			}
			if ((m_RWAddress+m_RWLen)>8)
			{
				m_RWLen=8-m_RWAddress;
				UpdateData(FALSE);
				len=8-m_RWAddress;
			}
			break;
		case 0x03:
			if (m_RWAddress<0)
			{
				MessageBox("Please input Location of Tag Address more than 0!","Warning",MB_ICONWARNING);
				GetDlgItem(IDC_EDIT4)->SetFocus();
				((CEdit *) GetDlgItem(IDC_EDIT4))->SetSel(0,-1);
				UpdateData(FALSE);
				return;
			}
			break;
		}
		ptr=m_RWAddress;

		int CurSel=m_TagID.GetCurSel();
		EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

		for(int i=0;i<EPC_Word*2;i++)
		{
			IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
		}

		for(i=0;i<5;i++)
		{
			Sleep(30);
			switch(ConnectMode)
			{
			case 0:
				res=Net_EPC1G2_WriteWordBlock(m_hSocket,EPC_Word,IDTemp,mem,ptr,len,mask,AccessPassword);			
				break;
			case 1:
				res=EPC1G2_WriteWordBlock(m_hScanner,EPC_Word,IDTemp,mem,ptr,len,mask,AccessPassword,RS485Address);			
				break;
			}
			if ((res==_OK) || (res==_write_prot_error) || (res==_memory_error) || (res==_password_error))
				break;
		}
	}

	if (res==_OK)
	{
		m_ListData.AddString("Write Successfully!");
	}
	else
	{
		str=ReportError(res);
		if (str=="Unbeknown Error!")
			str="Write Fail!";
		if (res==0x09)
			str="The access password is error!";
		m_ListData.AddString(str);
	}
}

void CEPCC1G2Test::OnButton1() 
{
	apiReturn res;
	CString str;
	BYTE AccessPassword[4];
	BYTE lock;
	int i,k;
	UpdateData(TRUE);

	if (m_LTagID.GetCount()<1)
	{
		MessageBox("Please read first then choose a tag!","Warning",MB_ICONWARNING);
		UpdateData(FALSE);
		return;
	}

	str=m_LAccessPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_LAccessPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT10)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT10))->SetSel(0,-1);
		return;
	}
	str=m_LAccessPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of AccessPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	int CurSel=m_TagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	k=MessageBox("Are you sure to protect this tag?","Notice",MB_YESNO|MB_ICONWARNING);
	if (k!=6) 
		return;

	if (m_Lmem==0)
	{
		mem=m_Password;
		lock=m_Condition+4;
	}
	else
	{
		mem=m_Lmem+1;
		lock=m_Condition2;
	}
	
	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}

	for(i=0;i<5;i++)
	{
		Sleep(30);
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_SetLock(m_hSocket,EPC_Word,IDTemp,mem,lock,AccessPassword);
			break;
		case 1:
			res=EPC1G2_SetLock(m_hScanner,EPC_Word,IDTemp,mem,lock,AccessPassword,RS485Address);
			break;
		}
		if ((res==_OK) || (res==_write_prot_error) || (res==_memory_error) || (res==_password_error))
			break;
	}

	if (res==_OK)
	{
		MessageBox("Set Protect successfully!","Notice",MB_ICONINFORMATION);
	}
	else
	{
		str=ReportError(res);
		if (str=="Unbeknown Error!")
			str="Set Protect Fail!";
	    if (res==0x09)
			str="The access password is error!";
		MessageBox(str,"Error",MB_ICONERROR);
	}
}

void CEPCC1G2Test::OnRadio19() 
{
	UpdateData(TRUE);
	OpenPassword=TRUE;
	UpdateStatus();
}

void CEPCC1G2Test::OnRadio20() 
{
	UpdateData(TRUE);
	OpenPassword=FALSE;
	UpdateStatus();
}

void CEPCC1G2Test::OnRadio21() 
{
	UpdateData(TRUE);
	OpenPassword=FALSE;
	UpdateStatus();
}

void CEPCC1G2Test::OnRadio22() 
{
	UpdateData(TRUE);
	OpenPassword=FALSE;
	UpdateStatus();
}


void CEPCC1G2Test::OnButton2() 
{
	apiReturn res;
	CString str;
	BYTE KillPassword[4];
	int i,k;
	UpdateData(TRUE);

	if (m_KTagID.GetCount()<1)
	{
		MessageBox("Please read first then choose a tag!","Warning",MB_ICONWARNING);
		UpdateData(FALSE);
		return;
	}

	str=m_KillPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_KillPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT9)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT9))->SetSel(0,-1);
		return;
	}
	str=m_KillPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of KillPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		KillPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	int CurSel=m_KTagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	k=MessageBox("Are you sure to Kill the tag?","Notice",MB_OKCANCEL|MB_ICONWARNING);
	if (k!=1) 
		return;

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}

	for(i=0;i<5;i++)
	{
		Sleep(30);
		res=EPC1G2_KillTag(m_hScanner,EPC_Word,IDTemp,KillPassword,RS485Address);
		if ((res==_OK) || (res==_write_prot_error) || (res==_memory_error) || (res==_password_error))
			break;
	}
	
	if (res==_OK)
	{
		MessageBox("Kill tag successfully!","Notice",MB_ICONINFORMATION);
	}
	else
	{
		str=ReportError(res);
		if (str=="Unbeknown Error!")
			str="Kill tag Fail!";
		if (res==0x09)
			str="The kill password is error!";
		MessageBox(str,"Error",MB_ICONERROR);
	}
}


void CEPCC1G2Test::OnButton3() 
{
	apiReturn res;
	CString str;
	BYTE AccessPassword[4];
	int i,k;
	UpdateData(TRUE);

	if (m_LBTagID.GetCount()<1)
	{
		MessageBox("Please read first then choose a tag!","Warning",MB_ICONWARNING);
		return;
	}

	if (m_LBAddress<0)
	{
		MessageBox("Please input Location of Tag Address more then 0!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT7)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT7))->SetSel(0,-1);
		return;
	}
	ptr=m_LBAddress;

	str=m_LBAccessPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_LBAccessPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT8)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT8))->SetSel(0,-1);
		return;
	}
	str=m_LBAccessPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of AccessPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	int CurSel=m_LBTagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	str.Format("Are you sure to set protect address %d of User?",m_LBAddress);
	k=MessageBox(str,"Notice",MB_OKCANCEL|MB_ICONWARNING);
	if (k!=1) 
		return;

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}

	for(i=0;i<5;i++)
	{
		Sleep(30);
		res=EPC1G2_BlockLock(m_hScanner,EPC_Word,IDTemp,ptr,AccessPassword,RS485Address);
		if ((res==_OK) || (res==_write_prot_error) || (res==_memory_error) || (res==_password_error))
			break;
	}
	
	if (res==_OK)
	{
		MessageBox("Set Protect successfully!","Notice",MB_ICONINFORMATION);
	}
	else
	{
		str=ReportError(res);
		if (str=="Unbeknown Error!")
			str="Set Protect Fail!";
		if (res==0x09)
			str="The access password is error!";
		MessageBox(str,"Error",MB_ICONERROR);
	}
}

void CEPCC1G2Test::OnButton5() 
{
	apiReturn res;
	CString str;
	BYTE AccessPassword[4];
	int i;
	UpdateData(TRUE);

	if (m_ATagID.GetCount()<1)
	{
		MessageBox("Please read first then choose a tag!","Warning",MB_ICONWARNING);
		return;
	}

	str=m_AAccessPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_AAccessPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT8)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT8))->SetSel(0,-1);
		return;
	}
	str=m_AAccessPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of AccessPassword!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}

	int CurSel=m_ATagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}

	for(i=0;i<5;i++)
	{
		Sleep(30);
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_ChangeEas(m_hSocket,EPC_Word,IDTemp,m_EasState,AccessPassword);
			break;
		case 1:
			res=EPC1G2_ChangeEas(m_hScanner,EPC_Word,IDTemp,m_EasState,AccessPassword,RS485Address);
			break;
		}
		if ((res==_OK) || (res==_password_error))
			break;
	}
	
	if (res==_OK)
	{
		MessageBox("Set Eas Alarm successfully!","Notice",MB_ICONINFORMATION);
	}
	else
	{
		str=ReportError(res);
		if (str=="Unbeknown Error!")
			str="Set Eas Alarm Fail!";
		if (res==0x09)
			str="The access password is error!";
		MessageBox(str,"Error",MB_ICONERROR);
	}
}

void CEPCC1G2Test::OnCheck7() 
{
	apiReturn res;
	UpdateData(TRUE);

	int interval[]={10,20,30,50,100,200,500};
	timer_interval=interval[m_Interval.GetCurSel()];
	if (m_EasAlarm)
	{
		m_antenna_sel=0;
		if(m_Antenna1)
		m_antenna_sel += 1;
		if(m_Antenna2)
		m_antenna_sel += 2;
		if(m_Antenna3)
		m_antenna_sel += 4;
		if(m_Antenna4)
		m_antenna_sel += 8;
		switch(m_antenna_sel)
		{
		case 0:
			MessageBox("Please choose one antenna at least!","Warning",MB_ICONWARNING);
			m_EasAlarm=FALSE;
			UpdateData(FALSE);
			return;
			break;
		case 1:
		case 2:
		case 4:
		case 8:
			switch(ConnectMode)
			{
			case 0:
				res=Net_SetAntenna(m_hSocket, m_antenna_sel);
				break;
			case 1:
				res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
				break;
			}
			if (res!=_OK)
			{
				MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
				m_EasAlarm=FALSE;
				UpdateData(FALSE);
				return;
			}
			break;
		}

		Read_times=0;
		UpdateStatus();
		SetTimer(3,timer_interval,NULL);
	}
	else
	{
		KillTimer(3);
		UpdateStatus();
	}
}

//
void CEPCC1G2Test::OnButton6() 
{
	// TODO: Add your control notification handler code here
	apiReturn res;
	CString str;
//	BYTE AccessPassword[4];
	int i;
	UpdateData(TRUE);

	if (m_PTagID.GetCount()<1)
	{
		MessageBox("Please read first than choose a tag!","Warning",MB_ICONWARNING);
		return;
	}
	str=m_RProtectPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_RProtectPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT13)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT13))->SetSel(0,-1);
		return;
	}
	str=m_RProtectPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of RStreadProtect Password!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}
	
	int CurSel=m_PTagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="SetAntenna Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<5;i++)
	{
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_ReadProtect(m_hSocket,AccessPassword,EPC_Word,IDTemp);
			break;
		case 1:
			res=EPC1G2_ReadProtect(m_hScanner,AccessPassword,EPC_Word,IDTemp,RS485Address);
			break;
		}
		if(res==_OK)
			break;
	}
	if(res!=_OK)
	{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="Read Protect Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			return;
	}
	else
	{
		MessageBox("Read Protect successfully!","Notice",MB_ICONINFORMATION);
	}

}

//λ
void CEPCC1G2Test::OnButton7() 
{
	// TODO: Add your control notification handler code here
	apiReturn res;
	CString str;
//	BYTE AccessPassword[4];
	int i;
	UpdateData(TRUE);

/*	if (m_PTagID.GetCount()<1)
	{
		MessageBox("Please read first than choose a tag!","Warning",MB_ICONWARNING);
		return;
	}
*/	str=m_RProtectPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_RProtectPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		GetDlgItem(IDC_EDIT13)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT13))->SetSel(0,-1);
		return;
	}
	str=m_RProtectPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of RStreadProtect Password!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}
	
	int CurSel=m_PTagID.GetCurSel();
	EPC_Word=EPCC1G2_IDBuffer[CurSel][0];

	for(i=0;i<EPC_Word*2;i++)
	{
		IDTemp[i]=EPCC1G2_IDBuffer[CurSel][i+1];
	}

	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="SetAntenna Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		return;
	}
	for(i=0;i<5;i++)
	{
		switch(ConnectMode)
		{
		case 0:
			res=Net_EPC1G2_RStreadProtect(m_hSocket,AccessPassword);
			break;
		case 1:
			res=EPC1G2_RStreadProtect(m_hScanner,AccessPassword,RS485Address);
			break;
		}
		if(res==_OK)
			break;
	}
	if(res!=_OK)
	{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="UnLockRead Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			return;
	}
	else
	{
		MessageBox("UnLockRead successfully!","Notice",MB_ICONINFORMATION);
	}
}

void CEPCC1G2Test::OnCheck9() 
{
	// TODO: Add your control notification handler code here
	apiReturn res;
	CString str;
//	BYTE AccessPassword[4];
	int i;
	UpdateData(TRUE);

	str=m_KPassword.SpanIncluding("0123456789ABCDEFabcdef");
	if(strlen(str)!=strlen(m_KPassword))
	{
		MessageBox("Please input HEX!","Warning",MB_ICONWARNING);
		m_Kword=FALSE;
		UpdateData(FALSE);
		GetDlgItem(IDC_EDIT14)->SetFocus();
		((CEdit *) GetDlgItem(IDC_EDIT14))->SetSel(0,-1);
		return;
	}
	str=m_KPassword;
	int str_len=strlen(str);
	if (str_len!=8)
	{
		MessageBox("Please input enough Length of RStreadProtect Password!","Warning",MB_ICONWARNING);
		m_Kword=FALSE;
		UpdateData(FALSE);
		return;
	}
	for(i=0;i<4;i++)
	{
		AccessPassword[i]=(BYTE)strtol((CString)str[i*2]+(CString)str[2*i+1],NULL,16);
	}
	
	m_antenna_sel=0;
	if(m_Antenna1)
	m_antenna_sel += 1;
	if(m_Antenna2)
	m_antenna_sel += 2;
	if(m_Antenna3)
	m_antenna_sel += 4;
	if(m_Antenna4)
	m_antenna_sel += 8;
	switch(m_antenna_sel)
	{
	case 1:
	case 2:
	case 4:
	case 8:
		switch(ConnectMode)
		{
		case 0:
			res=Net_SetAntenna(m_hSocket, m_antenna_sel);
			break;
		case 1:
			res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
			break;
		}
		if (res!=_OK)
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="SetAntenna Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			m_Kword=FALSE;
			UpdateData(FALSE);
			return;
		}
		break;
	default:
		MessageBox("Please choose only one antenna!","Warning",MB_ICONWARNING);
		m_Kword=FALSE;
		UpdateData(FALSE);
		return;
	}
	if(m_Kword)
	{
		UpdateStatus();
		for(i=0;i<5;i++)
		{
//			res=EPC1G2_Calibrate(m_hScanner,AccessPassword,1);
			if(res==_OK)
				break;
		}
		if(res!=_OK)
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="Open Calibrate Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			m_Kword=FALSE;
			UpdateStatus();
			UpdateData(FALSE);
			return;
		}
	}
	else
	{
		UpdateStatus();
		for(i=0;i<5;i++)
		{
//			res=EPC1G2_Calibrate(m_hScanner,AccessPassword,0);
			if(res==_OK)
				break;
		}
		if(res!=_OK)
		{
			str=ReportError(res);
			if (str=="Unbeknown Error!")
				str="Close Calibrate Fail!Please try again!";
			MessageBox(str,"Warning",MB_ICONWARNING);
			m_Kword=TRUE;
			UpdateStatus();
			UpdateData(FALSE);
			return;
		}
	}
	
}
//ǩ
void CEPCC1G2Test::OnCheck10() 
{
	// TODO: Add your control notification handler code here
	apiReturn res;
	UpdateData(TRUE);

	Detect=0;
	int interval[]={10,20,30,50,100,200,500};
	timer_interval=interval[m_Interval.GetCurSel()];
	if (m_DetectTag)
	{
		m_antenna_sel=0;
		if(m_Antenna1)
		m_antenna_sel += 1;
		if(m_Antenna2)
		m_antenna_sel += 2;
		if(m_Antenna3)
		m_antenna_sel += 4;
		if(m_Antenna4)
		m_antenna_sel += 8;
		switch(m_antenna_sel)
		{
		case 0:
			MessageBox("Please choose one antenna at least!","Warning",MB_ICONWARNING);
			m_DetectTag=FALSE;
			UpdateData(FALSE);
			return;
			break;
		case 1:
		case 2:
		case 4:
		case 8:
			switch(ConnectMode)
			{
			case 0:
				res=Net_SetAntenna(m_hSocket, m_antenna_sel);
				break;
			case 1:
				res=SetAntenna(m_hScanner, m_antenna_sel,RS485Address);
				break;
			}
			if (res!=_OK)
			{
				MessageBox("SetAntenna Fail!Please try again!","Warning",MB_ICONWARNING);
				m_DetectTag=FALSE;
				UpdateData(FALSE);
				return;
			}
			break;
		}

		m_ListID.DeleteAllItems();
		Read_times=0;
		UpdateStatus();
		SetTimer(4,timer_interval,NULL);
	}
	else
	{
		KillTimer(4);
		UpdateStatus();
	}	
}

BOOL CEPCC1G2Test::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	CString str,strtemp;
//	HWND hand;
	GetDlgItem(IDD_EPCC1G2_DIALOG)->m_hWnd;
	if(pMsg->message == WM_MOUSEMOVE )
	{
		POINT pt = pMsg->pt;
        ScreenToClient( &pt );

//		GetDlgItemText(m_hWnd,str);
	}
	
	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CEPCC1G2Test::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CPropertyPage::OnShowWindow(bShow, nStatus);
	
	UpdateStatus();
	
}
