#include "WINSOCK2.h"

#pragma comment(lib, "wsock32.lib")
#pragma comment(lib, "ws2_32.lib")

//==============================Ͷ==============================
typedef int apiReturn;   // ֵ
//============================================================
#define	ID_MAX_SIZE_64BIT	8		//ӱǩIDΪ64bit
#define ID_MAX_SIZE_96BIT	65		//ӱǩID
#define MAX_LABELS			100		// һζд಻100ǩ

//==============================API==============================
#define	_OK					0x00	// ɹ

//ͨŷϢ
#define _init_rs232_err		0x81	//  ͨſڳʼʧ
#define _no_scanner			0x82	//  Ҳд
#define _comm_error         0x83	//  շͨݳ
#define _baudrate_error     0x84	//  òʳ
#define _init_net_error		0x85	//  ڳʼʧ
#define _net_error          0x86	//  շͨݳ

// дسϢ
#define _no_antenna			0x01   //ʧ
#define _no_label			0x02   //δ⵽ǩ
#define _invalid_label		0x03   //Ƿǩ
#define _less_power			0x04   //дʲ
#define _write_prot_error	0x05   //д
#define _check_sum_error	0x06   //Уʹ
#define _parameter_error	0x07   //
#define _memory_error		0x08   //
#define _password_error		0x09   //벻ȷ
#define _killpassword_error	0x0a   //G2ǩΪȫ
#define _nonlicet_command	0x0b   //Ƿ
#define _nonlicet_user		0x0c   //벻ƥķǷû
#define _invalid_command	0x1e   //ʾЧָȷָ
#define _other_error		0x1f   //δ֪

//
#define _no_cardID_input   0x20   //

typedef struct tagReaderDate
{
	BYTE	Year;			//
	BYTE	Month;			//
	BYTE	Day;			//
	BYTE	Hour;			//ʱ
	BYTE	Minute;			//
	BYTE	Second;			//
}ReaderDate;


typedef struct tagReader2200Param
{
	BYTE	BaudRate;			//ڵͨʣȡֵ00H~08Hͬ"趨"
	BYTE	Power;				//书ֵȡֵ30~160
	BYTE	Min_Frequence;		//΢źƵʵʼ㣬ȡֵ 1~63
	BYTE	Antenna;			//ѡ1-ant1,2-ant2,4-ant4,8-ant8
	BYTE	WorkMode;			//дʽ1-ʱʽ2-ʽ3-ʽ4-ʱʽ25-ʽ2 
	BYTE	ReadInterval;		// 0-10ms, 1-30ms, 2-50ms
	BYTE	OutMode;			//ʽ(ֱ,׼)
	BYTE	TriggerMode;	    //ʽ
	BYTE	IDPosition;			//ڵӱǩϵĴŵַ
	BYTE	IfTestValidity;		//ǩǷϷ
	BYTE	OutInterface;		//ӿں͸ʽ(Wiegan26,Wiegan34,RS485,RS232,RJ45)
	BYTE	NumofCard;			//Ŀ
	BYTE	Power2;				//书ϵ2 ȡֵ30~160
	BYTE	TagType;			//ǩࣺ01HISO18000-6B02HEPCC104HEPCC1G208HTK900
	BYTE	WiegandWidth;		//Weigandֵ
	BYTE	WiegandInterval;	//Weigandֵ
	BYTE	ID_Start;			//ŵʼλȡֵ04
	BYTE	Max_Frequence;		//΢źƵʵֹ㣬ȡֵ 1~63
	BYTE	ReadDuration;		//ʱ䣺Ƶʱ䣬ֻTK900ǩЧ010ms120ms230ms340ms
	BYTE	StandardTime;		//׼ʱȱʡֵΪ120룬1255
	BYTE	EnableBuzzer;		//1:ʹܷ0:ʹܷ
	BYTE	ReaderAddress;		//0-255
	BYTE	HostIP1;			//λIPַ1
	BYTE	HostIP2;			//λIPַ2
	BYTE	HostIP3;			//λIPַ3
	BYTE	HostIP4;			//λIPַ4
	BYTE	HostPort1;			//λ˿1
	BYTE	HostPort2;			//λ˿2
	BYTE	Reserve29;			//
	BYTE	Reserve30;			//
	BYTE	TX_Mode;			//ģʽ0-ʾշģʽ1-ʾģʽ
	BYTE	Modulation;			//ã0-ʾ޵źţ1-ʾеźš
} Reader1000Param;

typedef struct tagReaderDebugState
{
	BYTE	Test;				//0״̬1״̬
	BYTE	Reserve2;			//
	BYTE	Reserve3;			//
	BYTE	Reserve4;			//
} ReaderDebugState;

//============================================================

//Ӷд
apiReturn _stdcall ConnectScanner(HANDLE *hScanner, char *szPort, int nBaudRate);

//Ͽ
apiReturn _stdcall DisconnectScanner(HANDLE hScanner);

//==============================豸==============================
//ò
apiReturn _stdcall SetBaudRate(HANDLE hScanner, int nBaudRate,int Address);

//ȡ汾
apiReturn _stdcall GetReaderVersion(HANDLE hScanner, WORD *wHardVer, WORD  *wSoftVer,int Address);

//öд̵״̬
apiReturn _stdcall SetRelay(HANDLE hScanner, int Relay,int Address);

//趨
apiReturn _stdcall SetOutputPower(HANDLE hScanner, int nPower1,int Address);

//趨Ƶ
apiReturn _stdcall SetFrequency(HANDLE hScanner, int Min_Frequency, int Max_Frequency,int Address);

//ȡд
apiReturn _stdcall ReadParam(HANDLE hScanner, Reader1000Param * pParam,int Address);

//öд
apiReturn _stdcall WriteParam(HANDLE hScanner, Reader1000Param * pParam,int Address);

//ȡд
apiReturn _stdcall ReadFactoryParameter(HANDLE hScanner);

//ѡ
apiReturn _stdcall SetAntenna(HANDLE hScanner, int Antenna,int Address);

//λд
apiReturn _stdcall Reboot(HANDLE hScanner,int Address);

//ʱ
apiReturn _stdcall SetReaderTime(HANDLE hScanner, ReaderDate time,int Address);

//ʱ
apiReturn _stdcall GetReaderTime(HANDLE hScanner, ReaderDate *time,int Address);

//
apiReturn _stdcall AddLableID(HANDLE hScanner, int listlen, int datalen, BYTE * data);

//ɾ
apiReturn _stdcall DelLableID(HANDLE hScanner, int listlen, int datalen, BYTE * data);

//
apiReturn _stdcall GetLableID(HANDLE hScanner, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//ü¼
apiReturn _stdcall GetRecord(HANDLE hScanner, ReaderDate *stime, ReaderDate *etime, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//ɾȫ¼
apiReturn _stdcall DeleteAllRecord(HANDLE hScanner);

//============================================================
//öдIPַ
apiReturn _stdcall SetReaderNetwork(HANDLE hScanner, BYTE IP_Address[4], int Port, BYTE Mask[4], BYTE Gateway[4]);

//öдIPַ
apiReturn _stdcall GetReaderNetwork(HANDLE hScanner, BYTE *IP_Address, int *Port, BYTE *Mask, BYTE *Gateway);

//öдMACַ
apiReturn _stdcall SetReaderMAC(HANDLE hScanner, BYTE MAC[6]);

//öдMACַ
apiReturn _stdcall GetReaderMAC(HANDLE hScanner, BYTE *MAC);

//==============================ISO-6Bݶд==============================
//ǩ
apiReturn _stdcall ISO6B_LabelPresent(HANDLE hScanner, int *nCounter,int Address);

//ȡISO6BǩID
apiReturn _stdcall ISO6B_ReadLabelID(HANDLE hScanner, BYTE *IDBuffer, int *nCounter,int Address);

//гѡǩ
apiReturn _stdcall ISO6B_ListSelectedID(HANDLE hScanner, int Cmd, int ptr, BYTE Mask, BYTE *Data, BYTE *IDBuffer, int *nCounter,int Address);

//һ
apiReturn _stdcall ISO6B_ReadByteBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data,int Address);

//һд4ֽ
apiReturn _stdcall ISO6B_WriteByteBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//һдһֽ
apiReturn _stdcall ISO6B_WriteAByte(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//дݣֽ16
apiReturn _stdcall ISO6B_WriteLongBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//д״̬
apiReturn _stdcall ISO6B_WriteProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr,int Address);

//д״̬
apiReturn _stdcall ISO6B_ReadWriteProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE *Protected,int Address);

//ȫ
apiReturn _stdcall ISO6B_ClearMemory(HANDLE hScanner, BYTE CardType, BYTE *IDBuffer,int Address);

//öдID
apiReturn _stdcall GetReaderID(HANDLE hScanner, BYTE *ReaderID);

//==============================EPC C1G2ݶд==============================
//ȡEPC1G2ǩID
apiReturn _stdcall EPC1G2_ReadLabelID(HANDLE hScanner, BYTE mem, int ptr, BYTE len, BYTE *mask, BYTE *IDBuffer, int *nCounter,int Address);

//һ
apiReturn _stdcall EPC1G2_ReadWordBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//дһ
apiReturn _stdcall EPC1G2_WriteWordBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//öд״̬
apiReturn _stdcall EPC1G2_SetLock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE Lock, BYTE *AccessPassword,int Address);

//ǩ
apiReturn _stdcall EPC1G2_EraseBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len,int Address);

//߱ǩ
apiReturn _stdcall EPC1G2_KillTag(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE *KillPassword,int Address);

//дEPC
apiReturn _stdcall EPC1G2_WriteEPC(HANDLE hScanner, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//
apiReturn _stdcall EPC1G2_BlockLock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE ptr, BYTE *AccessPassword,int Address);

//EAS״̬
apiReturn _stdcall EPC1G2_ChangeEas(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE State, BYTE *AccessPassword,int Address);

//EAS
apiReturn _stdcall EPC1G2_EasAlarm(HANDLE hScanner,int Address);

//
apiReturn _stdcall EPC1G2_ReadProtect(HANDLE hScanner,BYTE *AccessPassword, BYTE EPC_WORD, BYTE *IDBuffer,int Address);

//λ
apiReturn _stdcall EPC1G2_RStreadProtect(HANDLE hScanner, BYTE *AccessPassword,int Address);

//ƵУ
apiReturn _stdcall EPC1G2_Calibrate(HANDLE hScanner, BYTE *AccessPassword, BYTE Kword);

//ǩ
apiReturn _stdcall EPC1G2_DetectTag(HANDLE hScanner,int Address);
//==============================TK900ݶд==============================
//ȡTK900ǩID
apiReturn _stdcall TK900_ReadLabelID(HANDLE hScanner, BYTE *IDBuffer, int *nCounter,int Address);

//һ
apiReturn _stdcall TK900_ReadPageBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data,int Address);

//дһ
apiReturn _stdcall TK900_WritePageBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE *Data,int Address);

//д״̬
apiReturn _stdcall TK900_SetProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,int Address);

//д״̬
apiReturn _stdcall TK900_GetProtect(HANDLE hScanner, BYTE *IDBuffer ,BYTE *state,int Address);

//ñǩTTO״̬
apiReturn _stdcall TK900_SetTTO(HANDLE hScanner, BYTE *IDBuffer ,BYTE ptr, BYTE len,int Address);

//ȡTTOǩ
apiReturn _stdcall TK900_ListTagPage(HANDLE hScanner, BYTE *IDBuffer ,BYTE *Data,int Address);

//õTTOǩĿʼַͳ
apiReturn _stdcall TK900_GetTTOStartAdd(HANDLE hScanner, BYTE *IDBuffer ,BYTE *len,int Address);

//==============================ں==============================
//Ӷд
apiReturn _stdcall Net_ConnectScanner(SOCKET *hSocket,char *nTargetAddress,UINT nTargetPort,char *nHostAddress,UINT nHostPort);

//Ͽ
apiReturn _stdcall Net_DisconnectScanner();

//==============================豸==============================
//ò
apiReturn _stdcall Net_SetBaudRate(SOCKET hSocket, int nBaudRate);

//ȡ汾
apiReturn _stdcall Net_GetReaderVersion(SOCKET hSocket, WORD *wHardVer, WORD  *wSoftVer);

//趨
apiReturn _stdcall Net_SetOutputPower(SOCKET hSocket, int nPower);

//趨Ƶ
apiReturn _stdcall Net_SetFrequency(SOCKET hSocket, int Min_Frequency, int Max_Frequency);

//ȡд
apiReturn _stdcall Net_ReadParam(SOCKET hSocket, Reader1000Param *pParam);

//õƶ
apiReturn _stdcall Net_SetModDepth(SOCKET hSocket, int ModDepth);

//õƶ
apiReturn _stdcall Net_GetModDepth(SOCKET hSocket, int *ModDepth);

//öд
apiReturn _stdcall Net_WriteParam(SOCKET hSocket, Reader1000Param *pParam);

//ѡ
apiReturn _stdcall Net_SetAntenna(SOCKET hSocket, int Antenna);

//ȡд
apiReturn _stdcall Net_ReadFactoryParameter(SOCKET hSocket);

//λд
apiReturn _stdcall Net_Reboot(SOCKET hSocket);

//ʱ
apiReturn _stdcall Net_SetReaderTime(SOCKET hSocket, ReaderDate time);

//ʱ
apiReturn _stdcall Net_GetReaderTime(SOCKET hSocket, ReaderDate *time);

//
apiReturn _stdcall Net_AddLableID(SOCKET hSocket, int listlen, int datalen, BYTE * data);

//ɾ
apiReturn _stdcall Net_DelLableID(SOCKET hSocket, int listlen, int datalen, BYTE * data);

//
apiReturn _stdcall Net_GetLableID(SOCKET hSocket, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//ü¼
apiReturn _stdcall Net_GetRecord(SOCKET hSocket, ReaderDate *stime, ReaderDate *etime, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//ɾȫ¼
apiReturn _stdcall Net_DeleteAllRecord(SOCKET hSocket);

//============================================================
//öдIPַ
apiReturn _stdcall Net_SetReaderNetwork(SOCKET hSocket, BYTE IP_Address[4], int Port, BYTE Mask[4], BYTE Gateway[4]);

//öдIPַ
apiReturn _stdcall Net_GetReaderNetwork(SOCKET hSocket, BYTE *IP_Address, int *Port, BYTE *Mask, BYTE *Gateway);

//öдMACַ
apiReturn _stdcall Net_SetReaderMAC(SOCKET hSocket, BYTE MAC[6]);

//öдMACַ
apiReturn _stdcall Net_GetReaderMAC(SOCKET hSocket, BYTE *MAC);

//öдID
apiReturn _stdcall Net_GetReaderID(SOCKET hSocket, BYTE *ReaderID);

//==============================IO==============================
//öд̵״̬
apiReturn _stdcall Net_SetRelay(SOCKET hSocket, int relay);

//öд̵״̬
apiReturn _stdcall Net_GetRelay(SOCKET hSocket, int *relay);

//==============================ISO-6Bݶд==============================
//ǩ
apiReturn _stdcall Net_ISO6B_LabelPresent(SOCKET hSocket, int *nCounter);

//ȡISO6BǩID
apiReturn _stdcall Net_ISO6B_ReadLabelID(SOCKET hSocket, BYTE *IDBuffer, int *nCounter);

//гѡǩ
apiReturn _stdcall Net_ISO6B_ListSelectedID(SOCKET hSocket, int Cmd, int ptr, BYTE Mask, BYTE *Data, BYTE *IDBuffer, int *nCounter);

//һ
apiReturn _stdcall Net_ISO6B_ReadByteBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data);

//һд4ֽ
apiReturn _stdcall Net_ISO6B_WriteByteBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data);

//һдһֽ
apiReturn _stdcall Net_ISO6B_WriteAByte(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data);

//д״̬
apiReturn _stdcall Net_ISO6B_WriteProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr);

//д״̬
apiReturn _stdcall Net_ISO6B_ReadWriteProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE *Protected);

//==============================EPC C1G2ݶд==============================
//ȡEPC1G2ǩID
apiReturn _stdcall Net_EPC1G2_ReadLabelID(SOCKET hSocket, BYTE mem, int ptr, BYTE len, BYTE *mask, BYTE *IDBuffer, int *nCounter);

//һ
apiReturn _stdcall Net_EPC1G2_ReadWordBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword);

//дһ
apiReturn _stdcall Net_EPC1G2_WriteWordBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword);

//öд״̬
apiReturn _stdcall Net_EPC1G2_SetLock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE Lock, BYTE *AccessPassword);

//ǩ
apiReturn _stdcall Net_EPC1G2_EraseBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len);

//дEPC
apiReturn _stdcall Net_EPC1G2_WriteEPC(SOCKET hSocket,BYTE len, BYTE *Data, BYTE *AccessPassword);

//
apiReturn _stdcall Net_EPC1G2_BlockLock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE ptr, BYTE *AccessPassword);

//EAS״̬
apiReturn _stdcall Net_EPC1G2_ChangeEas(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE State, BYTE *AccessPassword);

//EAS
apiReturn _stdcall Net_EPC1G2_EasAlarm(SOCKET hSocket);

//
apiReturn _stdcall Net_EPC1G2_ReadProtect(SOCKET hSocket,BYTE *AccessPassword, BYTE EPC_WORD, BYTE *IDBuffer);

//λ
apiReturn _stdcall Net_EPC1G2_RStreadProtect(SOCKET hSocket, BYTE *AccessPassword);

//ǩ
apiReturn _stdcall Net_EPC1G2_DetectTag(SOCKET hSocket);

//==============================TK900ݶд==============================
//ȡTK900ǩID
apiReturn _stdcall Net_TK900_ReadLabelID(SOCKET hSocket, BYTE *IDBuffer, int *nCounter);

//һ
apiReturn _stdcall Net_TK900_ReadPageBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data);

//дһ
apiReturn _stdcall Net_TK900_WritePageBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE *Data);

//д״̬
apiReturn _stdcall Net_TK900_SetProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len);

//д״̬
apiReturn _stdcall Net_TK900_GetProtect(SOCKET hSocket, BYTE *IDBuffer ,BYTE *state);

//ñǩTTO״̬
apiReturn _stdcall Net_TK900_SetTTO(SOCKET hSocket, BYTE *IDBuffer ,BYTE ptr, BYTE len);

//ȡTTOǩ
apiReturn _stdcall Net_TK900_ListTagPage(SOCKET hSocket, BYTE *IDBuffer ,BYTE *Data);

//õTTOǩĿʼַͳ
apiReturn _stdcall Net_TK900_GetTTOStartAdd(SOCKET hSocket, BYTE *IDBuffer ,BYTE *len);


