// ReaderDemoDlg.h : header file
//

#if !defined(AFX_READERDEMODLG_H__325AD4E6_6A56_46B9_86DD_7C6E576328FC__INCLUDED_)
#define AFX_READERDEMODLG_H__325AD4E6_6A56_46B9_86DD_7C6E576328FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ReaderParameter.h"
#include "EPCC1G2Test.h"
#include "TK900Test.h"
#include "ISO6BTest.h"
#include "ConnectReader.h"

/////////////////////////////////////////////////////////////////////////////
// CReaderDemoDlg dialog

class CReaderDemoDlg : public CDialog
{
// Construction
public:
	CReaderDemoDlg(CWnd* pParent = NULL);	// standard constructor

	CPropertySheet m_Sheet;
	CReaderParameter m_ReaderParameterPage;
	CEPCC1G2Test m_EPCC1G2TestPage;
	CTK900Test m_TK900TestPage;
	CISO6BTest m_ISO6BTestPage;
	CConnectReader m_ConnectReaderPage;

// Dialog Data
	//{{AFX_DATA(CReaderDemoDlg)
	enum { IDD = IDD_READERDEMO_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReaderDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CReaderDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_READERDEMODLG_H__325AD4E6_6A56_46B9_86DD_7C6E576328FC__INCLUDED_)
